c
code for listb
      subroutine listb
c--dummy routine to identify the module
      return
      end
c
code for swxx
      subroutine swxx(in,jn)
c--print the list type in
c-- in= 8   sigma2
c-- in= 9   psizero
c-- in=10   negative sigma2
c-- in=11   enant. sensitive sigma2
c-- in=24   psi-e triplets
c-- in=20   negative quartets
c-- in=21   enantiomorphous quatets
c-- in=26   one phase seminvariants
c-- in=27   two phase seminvariants
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xtemp/temp(80)
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/dcmt/nor(4),nop(4),nsgn(4),gi,ifas,nphasv,ift1,ift2,ift3
      common/lst07/l7,l7a,l7d,ld7p,m7,m7dk,n7dk,md7d,n7d,n7,n7p,
     2 l7rs,l7rk,l7in,l7f,l7e,l7p,n7f,n7dd,ks1,ks2,ks3,sys07
      common/lst08/l8,m8,md8,n8,n8xa,n8xd,n8xe,icod8,n8p,l8d,n8d
      common/xdata/istore(800000)
      dimension     store(800000)
      equivalence (istore,store)
      dimension ist(2,5),gt(5),iphit(5),ill(3)
      character*60 ifmt
      call xfl02
      i=1
      call xfl07(i)
      if(i.eq.1) goto 30
      call xwarni
      write(ncwu,40)
40    format(1x,'not enough room in store')
      goto 3000
30    continue
      istp=0
      ix=0
      call xflxx(ix,in,n8xa,n8,n8xd,n8xe,icod8,l8,md8,l8d,n8d)
      ja=in-7
      go to(80 ,90 ,100,110 ,3000,3000,3000,3000,3000,3000,3000,
     1 3000,200,210,3000,3000,240,3000,260,270),ja
      goto 3000
80    write(ncwu,81) n8
81    format(/,' number of positive triplets =',i6)
      ncont=3
      ifmt='(i10,1h),3x,3i5,7x,f6.2,i6)'
      jump=3
      istp=1
      goto 400
90    write(ncwu,91) n8
91    format(/,' number of psi zero relationships =',i6)
      jump=5
      ncont=2
      ifmt='(i10,1h),3x,2i5,12x,f6.2,i6)'
      goto 400
100   write(ncwu,101) n8
101   format(/,' number of negative triplets =',i6)
      jump=3
      ncont=3
      ifmt='(i10,1h),3x,3i5,7x,f6.2,i6)'
      goto 400
110   write(ncwu,111) n8
111   format(/,' number of enant. sensitive triplets =',i6)
      jump=3
      ncont=3
      ifmt='(i10,1h),3x,3i5,7x,f6.2,i6)'
      goto 400
240   write(ncwu,131) n8
131   format(/,' number of psi-e triplets =',i6)
      jump=3
      ncont=3
      ifmt='(i10,1h),3x,3i5,7x,f6.2,i6)'
      goto 400
260   write(ncwu,191) n8
191   format(/,' number of one phase seminvariants =',i6)
      jump=1
      ncont=1
      ifmt='(i10,1h),3x,i5,17x,f6.2,i6)'
      goto 400
200   write(ncwu,201) n8
201   format(/,' number of negative quartets =',i6)
      jump=4
      ncont=4
      ifmt='(i10,1h),3x,4i5,2x,f6.2,i6)'
      goto 400
210   write(ncwu,211) n8
211   format(/,' number of enant. sensitive quartets =',i6)
      jump=4
      ncont=4
      ifmt='(i10,1h),3x,4i5,2x,f6.2,i6)'
      goto 400
270   write(ncwu,231) n8
231   format(/,' number of two phase seminvariants =',i6)
      jump=2
      ncont=2
      ifmt='(i10,1h),3x,2i5,12x,f6.2,i6)'
  400 continue
      if(istp.eq.1.and.jn.eq.0)go to 2000
      if(jn.eq.0) jn=n8
      jn=min0(jn,n8)
      write(ncwu,401)jn
  401 format(' number of strongest relationships =',i6,/)
      m8=l8
      do 1000 i=1,jn
      call dcmp(m8,jump)
      do 1210 n=1,4
      if(nsgn(n).eq.-1) nor(n)=-nor(n)
1210  continue
      ifas=kintk(ifas*15.0)
      if(ifas.ge.360) ifas=ifas-360
      ifas=iabs(360)
      write(ncwu,ifmt)i,(nor(j),j=1,ncont),gi,ifas
      m8=m8+md8
 1000 continue
      call xline
      return
 2000 continue
c--print the complete triplet's list
      ldum=nfl
      ndum=n8*3
      m=ldum
      md=5
      mdd=md*3
      m8=l8
      do 2001 i=1,n8
      call dcmp(m8,jump)
      istore(m   )=nor(1)
      istore(m+1 )=nor(2)
      istore(m+2 )=nor(3)
      istore(m+3 )=kintk(gi*100)
      istore(m+4 )=ifas
      istore(m+5 )=nor(2)
      istore(m+6 )=nor(1)
      istore(m+7 )=nor(3)
      istore(m+8 )=kintk(gi*100)
      istore(m+9 )=ifas
      istore(m+10)=nor(3)
      istore(m+11)=nor(1)
      istore(m+12)=nor(2)
      istore(m+13)=kintk(gi*100)
      istore(m+14)=ifas
      m=m+mdd
      m8=m8+md8
2001  continue
      i=0
      call sorty(ldum,ndum,md,i)
      l=l7f
      i=1
      m =ldum
 2300 continue
      j=istore(m)
      ma=l+(j-1)*md7d
      ill(1)=store(ma  )
      ill(2)=store(ma+1)
      ill(3)=store(ma+2)
      e1=store(ma+3)
      iphi=store(ma+6)
      write(ncwu,2301)(ill(n),n=1,3),j,e1,iphi
 2301 format(/,' reflection ',3i4,10x,
     1         'code = ',i4,10x,
     2            'e = ',f7.2,10x,
     3        'phase = ',i7,/)
      jt=0
      js=0
 2310 continue
      jt=jt+1
      js=js+1
      ist(1,jt)=istore(m+1)
      ist(2,jt)=istore(m+2)
      gt(jt)=float(istore(m+3))/100.
      iphit(jt)=istore(m+4)
      if(jt.ne.5)go to 2400
      write(ncwu,2350)((ist(n,nn),n=1,2),gt(nn),iphit(nn),nn=1,5)
 2350 format(5(3x,2i5,f7.2,i5))
      jt=0
 2400 continue
      i=i+1
      m =m +md
      if(i.gt.ndum)go to 2500
      if(j.eq.istore(m))go to 2310
      if(jt.ne.0)
     1write(ncwu,2350)((ist(n,nn),n=1,2),gt(nn),iphit(nn),nn=1,jt)
      write(ncwu,2401)js
 2401 format(' number of contributors =',i6)
      go to 2300
 2500 continue
      if(jt.ne.0)
     1write(ncwu,2350)((ist(n,nn),n=1,2),gt(nn),iphit(nn),nn=1,jt)
      write(ncwu,2401)js
3000  continue
      call xline
      return
      end
c
code for sr17
      subroutine sr17
c--read list 17, atomic group(s)
c
      common/lst17/ l17o,m17o,md17o,n17o,l17,m17,md17,n17
     2 ,l173,m173,md173,n173
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/xtemp/itemp(80)
      dimension temp(40)
      equivalence(itemp,temp)
c
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)
c--
      character*40 iarg,iarg1,iarg0
      data iarg/'group name and multiplicity or ##'/
      data iarg1/'atomic parameters or ##'/
      data iarg0/'cell (axes and angles)'/
c--
      in=17
      call xxcln(in)
      l17o=nfl+10
      n17o=0
      md17o=15
      md17=8
      store(nfl+5)=l17o-nfl
      store(nfl+7)=md17o
      store(nfl+8)=md17
      m17o=l17o
1000  continue
      call sty(iarg)
      if(klnc(in)) 2000,1010,2000
1010  continue
      if(jrca(itemp,n)) 9000,1017,9000
1017  continue
      n17o=n17o+1
      m17oi=m17o
      istore(m17oi)=itemp(1)
      store(m17o+1)=kredi(in)
      call sty(iarg0)
      if(klnc(in)) 9000,1020,9000
1020  continue
      if(kredf(temp,6)) 9000,1030,9000
1030  continue
      lj=m17o+3
      call trasf(lj,1,6)
      m17=m17o+md17o
      n17=0
1050  continue
      call sty(iarg1)
      if(klnc(in)) 1100,1060,1100
1060  continue
      if(jrca(itemp,n)) 9000,1065,9000
1065  continue
      n17=n17+1
      m17i=m17
      istore(m17i)=itemp(1)
      if(kredf(temp,3)) 9000,1070,9000
1070  continue
      lj=m17+1
      call trasf(lj,1,3)
      l=m17o+2
      lj=m17+1
      call xort(lj,l)
      m17=m17+md17
      go to 1050
1100  continue
      store(m17o+2)=n17
      m17o=m17
      go to 1000
2000  continue
      if(iabort) 2020,2020,9100
2020  continue
      store(nfl+6)=n17o
      write(ncwu,2010) n17o
2010  format(//,i6,16h group(s) stored)
      n=m17o-nfl
      call xfrml(in,n)
      return
9000  continue
      call xunkw
9100  continue
      return
      end
c
code for xort
      subroutine xort(lj,l)
c
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common /xdata/ store(800000)
c--
      a=1.0
      l2=l+3
      l3=l+6
      l4=l+9
      do 1000 n=1,3
      store(l4)=sin(dtr*store(l2))
      store(l3)=cos(dtr*store(l2))
      a=a-store(l3)*store(l3)
      l2=l2+1
      l3=l3+1
      l4=l4+1
1000  continue
      v=sqrt(a-2.0*store(l+6)
     1            *store(l+7)
     2            *store(l+8))
      a=store(l+2)*(store(l+6)-store(l+7)*
     1              store(l+8))/store(l+11)
      b=store(l+2)*v/store(l+11)
      store(lj+3)=store(l  )*store(lj  )+store(l+1)*
     1           store(l+8)*store(lj+1)+store(l+2)*
     2           store(l+7)*store(lj+2)
      store(lj+4)=store(l+1)*store(l+11)*store(lj+1)+
     1         a*store(lj+2)
      store(lj+5)=b*store(lj+2)
      return
      end
c
code for sw17
      subroutine sw17
c--print list 17, atomic group(s)
c
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c
      common/lst17/ l17o,m17o,md17o,n17o,l17,m17,md17,n17
     2 ,l173,m173,md173,n173
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
c
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)
c--
      in=17
      if(kprth(in)) 4000,2017,2017
4000  continue
      call xline
      return
2017  continue
      write(ncwu,2015)
2015  format( /,16h atomic group(s))
      call srdls(in,l,nfl,lj)
      n17o=store(nfl+6)
      l17o=store(nfl+5)+nfl
      md17o=store(nfl+7)
      md17 =store(nfl+8)
      write(ncwu,2021) n17o
2021  format( /,i6,9h group(s),/ )
      m17o=l17o
      do 3000 ja=1,n17o
      m17oi=m17o
      n17= store(m17o +2)
      jb = store(m17o +1)
      write(ncwu,2025) istore(m17oi),jb,n17
2025  format(  13h group name= ,a2,
     1 5x,14hmultiplicity= ,i4,
     1 5x,17hnumber of atoms= ,i4,/)
      lj=m17o+3
      lk=lj+5
      write(ncwu,2030) (store(l),l=lj,lk)
2030  format(7h cell =,3f10.3,3f10.2,//,
     1 6x,4hname,5x,1hx, 9x,1hy, 9x,1hz,
     2           9x,2hxo,8x,2hyo,8x,2hzo,/)
      m17=m17o+md17o
      do 2040 n=1,n17
      m17i=m17
      lj=m17+1
      li=lj+5
      write(ncwu,2045) istore(m17i),(store(l),l=lj,li)
2045  format(8x,a2,6f10.4)
      m17=m17+md17
2040  continue
      m17o=m17
3000  continue
      go to 4000
      end
c
code for xpre12
      subroutine xpre12
c--write preamble of list 12
c
      common/lst12/l12,m12,md12,n12,nbl12,idra,idrb,l12d,n12d,
     2	n12c,md12b,iover12(4)
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)
c--
      call xxcln(12)
c--ex md12=93 (13+80)
      md12b=17
      md12=md12b+80
c--ex md12a=13
      md12a=20
      l12=nfl+md12a                                                     
      store(nfl+6)=md12                                                 
      store(nfl+7)=md12a 
      do ll=8,md12a-1
      store(nfl+ll)=0.0
      enddo
      store(nfl+15)=md12b
      do i=1,4
      iover12(i)=0
      enddo
      nbl12=0
      n12=0
      return
      end
c
code for sr12
      subroutine sr12(iflag)
c--read symbolic list 12
c  in input:
c  iflag = 0 standard input list 12 (caoexe e semi)
c	 = 1 direttive di lista 12 da mnqd
c  in output:
c  iflag =  1 directive read but not for list 12
c	 =  0 end encountered
c        = -1 default directives read
c	 = -2 error
c
      common/lst12/l12,m12,md12,n12,nbl12,idra,idrb,l12d,n12d,
     2	n12c,md12b,iover12(4)
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/xtemp/itemp(80)
      dimension temp(40)
      equivalence(itemp,temp)
c
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)
c--
      dimension ifull(2)
      dimension jend(3)
      data jend/1he,1hn,1hd/
      character*40 iarg
      data iarg/'instruction(s) or ##'/
      data iset/4hdefa/,ifull/4hfull,4hdiag/
c--                                                                     
c      iflag=0
      ifirst=0
      call xpre12
      ncard=0
      m12=l12
c--check if have to read the first record
      if(iflag.eq.0) then 
        call sty(iarg)
        if(klnc(i)) 5000,1010,5000
      else
       goto 1010
      end if
c--read the other records
1005  continue
      if(klnc(i)) 5000,1010,5000
1010  continue       
      if(jrca(itemp,n)) 1015,1020,1015
1015  continue
      call xunkw
      go to 1005
1020  continue
      idrb=kcomp(1,itemp,iset,1,1)
      if(idrb) 1060,1060,1030
1030  continue
      if(jrca(itemp,n)) 1035,1040,1035
1035  continue
      in=1
      go to 1050
1040  continue
      in=kcomp(1,itemp,ifull,2,1)
      if(in) 1015,1015,1050
1050  continue
      inext=0
      if(iflag.eq.0) inext=1
      if(icrea12(in,inext,ladr,ncard).lt.0)go to 9040
      if(inext.eq.1) then
       call xpre12
       m12=l12
       mm=ladr
       do 2000 nn=1,ncard
       do i=1,80
	image(i)=istore(mm)
	mm=mm+1
       enddo
       nc=1
       nnn=nn
       icrea=1
       if(j12x(nnn,nat,icrea)) 5000,2000,2000
2000   continue
       goto 1005
      else
       iflag=-1
       return
      endif
1060  continue                                                   
      nc=1
      ncard=ncard+1
      icrea=0
      call xpcci
c      write(ncwu,*) nc,ncard, image                    
      if(j12x(ncard,nat,icrea)) 5000,1005,5002
5002  continue
      iflag=1
5000  continue
      if(iabort) 5010,5010,9030
5010  continue
      istore(m12  )=nat
      istore(m12+1)=0
      istore(m12+2)=0
      n12=n12+1
      l=m12+md12b
      do 5015 i=1,80
      istore(l)=image(i)
      l=l+1
5015  continue
      m12=m12+md12
      store(nfl+5)=n12
      store(nfl+12)=nbl12
      do i=1,4
      store(nfl+8+i-1)=iover12(i)
      enddo
      m12=m12
      j=m12 -nfl
      call xfrml(12,j)
      if(iflag.eq.0) call xline
      return
9040  write(ncwu,*)' error in sr12 '
      call xildr
      go to 1005
9030  continue
      if(iflag.eq.0) iabort=0
      iflag=-2
      return
      end
c
code for j12y
      function j12y(ladr,ncard)
c--create symbolic list 12 by program
c  ladr	 = address in istore which contains directives for list 12
c  ncard = no. of directives
c
      common/lst12/l12,m12,md12,n12,nbl12,idra,idrb,l12d,n12d,
     2	n12c,md12b,iover12(4)
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/xtemp/itemp(80)
      dimension temp(40)
      equivalence(itemp,temp)
c
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)
c--
      call xpre12
      m12=l12
      mm=ladr
      do 2000 nn=1,ncard
      do i=1,80
       image(i)=istore(mm)
       mm=mm+1
      enddo
c      write(ncwu,'(a,80a1)')'j12y : ',image
      nc=1
      nnn=nn
      icrea=1
      if(j12x(nnn,nat,icrea)) 5000,2000,2000
2000  continue
c--fine loop delle schede e inserisce la direttiva 'end'
5000  continue
      istore(m12  )=nat
      istore(m12+1)=0
      istore(m12+2)=0
      n12=n12+1
      l=m12+md12b
      do 5015 i=1,80
      istore(l)=image(i)
      l=l+1
5015  continue
      m12=m12+md12
      store(nfl+5)=n12
      store(nfl+12)=nbl12
      do i=1,4
      store(nfl+8+i-1)=iover12(i)
      enddo
      j=m12 -nfl
      call xfrml(12,j)
      j12y=0
      return
      end
c
code for j12x
      function j12x(ncard,nat1,icrea)
c--create symbolic list 12
c  j12x = -1 end directive read
c       =  0 directive ok
c       =  1 no list 12 directive
c  directive codes: 1 diag
c                   2 full
c                   3 block
c                   4 plus
c                   5 fix
c		    6 weight  --> factor
c                   7 equiv
c		    8 ride
c		    9 end
c		   10 fixed -> 5
c		   11 dist
c		   12 angle
c		   13 planar
c		   14 sum
c  argument type  : 1 no specification
c                   2 a1 un a2 p1 p2 . .
c                   ( a1 p1 p2 p3 . . . . )
c                   ( a1  a2  p1 p2 p3 ...)
c                   3 a1 un a2
c                   ( a1  )
c                   ( a1 a2 ...)
c                   4 p1 p2 p3 . . . . .
c                   5 a1 p1 a2 p2
c                   ( a1 until a2  p1 a3 until a4 p2 )
c                   ( a1 a2 ... p1  a11 a12 ... p2 )
c                   6 a1 p1  w
c                   ( a1 until a2  p1 w  )
c		    ( a1 a2 ... p1 w )
c		    ( a1 a2 d s )
c		    ( a1 a2 a3 cosd s )
c
      common/lst12/l12,m12,md12,n12,nbl12,idra,idrb,l12d,n12d,
     2	n12c,md12b,iover12(4)
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/xtemp/itemp(80)
      dimension temp(40)
      equivalence(itemp,temp)
c
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)
c--
      dimension itarg(14)
      dimension ipar(22),iover(4)
      data nat/14/
      data lun/22/
      data itarg/4hdiag,4hfull,4hbloc,4hplus,
     1		 4hfix ,4hfact,4hequi,4hride,4hend ,4hfixe,
     2		 4hdist,4hangl,4hplan,4hsum /
c      data ipar/ 4hx	,4hy   ,4hz   ,4h11  ,4h12  ,
c     2		 4h13  ,4h22  ,4h23  ,4h33  ,4hocc ,
c     3		 4hscal,4hbove,4hb[is,4hx's ,4hij  ,4hii  ,
c     4		 4hocc1,4hocc2,4hocc3,4hocc4/
      data ipar/ 4hx   ,4hy   ,4hz   ,4h11  ,4h12  ,
     2		 4h13  ,4h22  ,4h23  ,4h33  ,4hocc ,
     3		 4hocc1,4hocc2,4hocc3,4hocc4,
     4		 4hb[is,4hx's ,4hij  ,4hii  ,
     5		 4hscal,4hbove,4hexti,4hpola/
c--
c--definisco code della direttiva 'end'
      nat1=9
      j12x=0
      nc=1
      if(jrca(itemp,n)) 1040,1020,1040
1020  continue
c  process the directive
      idrb=kcomp(1,itemp,itarg,nat,1)
      if(idrb) 1040,1040,1030
1030  continue
c--put 'fixed' = 'fix'
      if(idrb.eq.10)idrb=5
      istore(m12 )=idrb
      go to(2001,2002,2003,3000,3000,
     1	    3000,3000,3000,5000,3000,
     2	    6000,6000,6100,6200,1040),idrb
1040  continue
      j12x=1
      call xunkw
1005  continue
      return
c
c--'diag' directive
2001  continue
      idra=idrb                                              
      if(n12 .ne.0) go to 9026
      nbl12=-1
      go to 4000
c
c--'full' directive
2002  continue
      idra=idrb
      if(n12 .ne.0) go to 9026
      nbl12=1
      go to 4000
c
c--'block' directive(s)
2003  continue
      idra=idrb
      nbl12=nbl12+1
      go to 4000
c
c--'plus' , 'fix' , 'factor' , 'equiv' , 'ride'	directive(s)
3000  continue
      if(n12 .eq.0) go to 9024
c
c--analyze the argument
4000  continue
      natoms=0
      nca=nc
      ncb=80
      if(jrca(itemp,n)) 4002,4005,4002
c--case directive and nothing else
4002  continue
      if(idrb.gt.5) goto 9006
      nca=0
      ncb=0
c--link for only atoms also
4003  continue
c--check equiv direct : atom1 atom2
      if(natoms.eq.2.and.idrb.eq.7) then
       nca=-nca
       goto 4900
      endif
      l=m12+3
      do i=1,9
      istore(l)=1
      l=l+1
      enddo
      go to 4900
c--case something else
4005  continue                                                          
      n=kcomp(1,itemp,ipar,lun,1)                                       
      if(n) 4010,4010,4006
c--case 1o parameter
4006  continue                                                          
      if(jparg(n,ipar,lun,ncx,iover)) 4800,4800,9028
c--case atom(s)
4010  continue
      natoms=natoms+1
      ncb=nc                                                            
      if(jrca(itemp,n)) 4003,4013,4003                                  
4013  continue                                                          
      n=kcomp(1,itemp,ipar,lun,1)                                       
      if(n) 4010,4010,4021
c--case 2o parameter
4021  continue                                                          
      if(jparg(n,ipar,lun,ncx,iover)) 4025,4025,4030
4025  continue
c--check equiv direct : atom1 atom2  p1
      if(natoms.eq.2.and.idrb.eq.7)then
       nca=-nca
       ncb=-ncb
       goto 4900
      endif
      if(idrb.eq.6) go to 9006
      if(idrb.ne.7) go to 4810
c--only 'equiv' directive (individua i due parametri)
c       write(ncwu,*)'solo equiv...'
      if(jparx(n)) 4026,4026,9028
4026  continue
      if(jparx(nn)) 4027,4027,9028
4027  continue
      istore(m12+3)=n
      istore(m12+4)=0
      istore(m12+5)=0
      istore(m12+6)=nn
      go to 4900
c--only 'factor' & 'equiv' directives
4030  continue                                                          
      if(idrb.eq.8)  go to 9028
      if(idrb.lt.6)  go to 9028
      if(jparx(n)) 4033,4033,9028
4033  continue
      istore(m12+3)=n
      nc=ncx
      if(idrb.eq.7) go to 4050
      jj=1
      if(jrdfl(temp,jj))9018,9018,4032
4032  continue
      istore(m12+4)=temp(1)*1000
      go to 4900
c--equiv directive
4050  continue                                                          
      nc1=nc                                                            
      if(jrca(itemp,n)) 9028,4055,9028                                  
4055  continue                                                          
      nc2=nc                                                            
      if(jrca(itemp,n)) 9028,4063,9028                                  
4063  continue                                                          
      n=kcomp(1,itemp,ipar,lun,1)                                       
      if(n) 4055,4055,4071
4071  continue                                                          
c      if(n.ge.17)n=n-6
      istore(m12+4)=nc1
      istore(m12+5)=nc2                                                 
      istore(m12+6)=n                                                   
      goto 4900
c                                                                       
c--common branch                                                        
4800  continue
      nca=0
      ncb=0
4810  continue
      do i=1,4
      if(iover(i).ne.0) then
       if(iover12(i).ne.0) goto 9028
       if(i.le.2) then
	if(idra.ne.3) goto 9028
       endif
       iover12(i)=n12+1
      endif
      enddo
4900  continue
      istore(m12 +1)=nca                                                
      istore(m12 +2)=ncb                                                
      n12=n12+1                                                         
      l=m12+md12b
      do i=1,80
      istore(l)=image(i)                                                
      l=l+1                                                             
      enddo
c      if(idrb.eq.6.or.idrb.eq.7) then
c      l=m12+md12b-1
c      write(ncwu,'(1x,20i5)')(istore(i),i=m12,l)
c      endif
      m12=m12+md12                                                      
      go to 1005                                                        
c                                                                       
c--'end' directive
5000  continue
      j12x=-1
      return
c
c--'dist' or 'angle' directive
6000  continue
      jj=2
      if(jrdfl(temp,jj))9018,9018,6032
6032  continue
      store(m12+3)=temp(1)
      store(m12+4)=temp(2)
      nca=nc
      ncb=80
      if(jrca(itemp,n)) 9006,6005,9006
6005  continue
      if(jrca(itemp,n)) 9006,6013,9006
6013  continue
      if(idrb.eq.12)  then
      if(jrca(itemp,n)) 9006,6014,9006
6014  continue
      endif
      ncb=nc
      store(nfl+13)=store(nfl+13)+1
      go to 4900                                                        
c
c--'planar' directive
6100  continue
      nca=nc
      jj=1
      if(kredf(temp,jj))9018,6132,6131
6131  continue
c--insert default value for sigma
      temp(1)=0.001
      nc=nca
6132  continue
      store(m12+3)=0.0
      store(m12+4)=temp(1)
      nca=nc
      ncb=80
6105  continue
      if(jrca(itemp,n)) 6110,6105,6110
6110  continue
      ncb=nc
      store(nfl+13)=store(nfl+13)+1
      go to 4900                                                        
c
c--'sum ' directive
6200  continue
      nca=nc
      jj=1
      if(kredf(temp,jj))9018,6232,6231
6231  continue
c--insert default value for sigma
      temp(1)=1.0e-05
      nc=nca
6232  continue
      store(m12+3)=0.0
      store(m12+4)=temp(1)
      nca=nc
      ncb=nc
      if(jrca(itemp,n)) 9006,6205,9006
6205  continue
      n=kcomp(1,itemp,ipar,lun,1)                                       
      if(n) 6210,6210,6206
c--paramtro per tutti gli atomi (non c'e' specificato atom)
6206  continue
c      if(n.ge.17)n=n-6
      istore(m12+5)=0
      istore(m12+6)=1
      istore(m12+7)=n
c--check if a floating origin restraints
      if(n.gt.3) goto 6230
      store(nfl+14)=n
      goto 6230
c--specificato atom
6210  continue
      ncb=nc
      if(jrca(itemp,n)) 9006,6213,9006
6213  continue
      n=kcomp(1,itemp,ipar,lun,1)                                       
      if(n) 6210,6210,6221
c--ora viene specificato il o i parametri
6221  continue
c      if(n.ge.17)n=n-6
      istore(m12+5)=1
      kpar=1
      m=m12+7
6223  continue
      istore(m)=n
      if(kpar.ge.10) goto 6227
      if(jrca(itemp,n)) 6227,6225,6227
6225  continue
      n=kcomp(1,itemp,ipar,lun,1)                                       
      if(n) 9006,9006,6222
6222  continue
c      if(n.ge.17)n=n-6
      m=m+1
      kpar=kpar+1
      goto 6223
6227  continue
      istore(m12+6)=kpar
6230  continue
      store(nfl+13)=store(nfl+13)+1
      go to 4900                                                        
c
c--error messages
9006  continue
      write(ncwu,9007) ncard
9007  format(2x,'card ',i2,2x,'error: wrong argument')
      go to 1005
9018  continue
      write(ncwu,9019) ncard
9019  format(2x,'card ',i2,2x,'error: paramemter ?')
      go to 1005
9024  continue
      write(ncwu,9025) ncard
9025  format(2x,'card ',i2,2x,'error: ',
     1 'the first directive must be /a/ type')
      go to 1005
9026  continue
      write(ncwu,9027) ncard
9027  format(2x,'card,',i2,2x,'error: there are incompatible'
     1 ' directives')
      go to 1005
9028  continue
      write(ncwu,9029) ncard,itemp(1)
9029  format(2x,'card ',i2,' error: ',a4,' unknown parameter')
      go to 1005                                                        
      end
c
code for jparx
      function jparx(nx)
c--check the parameter code
c
      common/lst12/l12,m12,md12,n12,nbl12,idra,idrb,l12d,n12d,
     2	n12c,md12b,iover12(4)
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
c
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)
c
      jparx=0
      nx=1
      m=m12+3
      l1=m12+md12b-1
      do 4031 l=m,l1
      ll=l
      if(istore(l).ne.0) go to 4033
      nx=nx+1
4031  continue
      jparx=1                                                           
      return                                                            
4033  continue                                                          
      istore(ll)=0                                                      
      return                                                            
      end                                                               
c                                                                       
code for jparg                                                          
      function jparg(np,ipar,lun,nca,iover)
c  store into list 12 the parameters included in the                    
c  argument of the directives                                           
c  np    first parameter read                                           
c  ipar  vector holding the parameter name                              
c  lun   number of parameter names                                      
c  nca   last address in image vector before last analysis
c  iover(1) 0/1 parameter 'scale' not found/ found
c  iover(2) 0/1 parameter 'boverall' not found/ found
c  iover(3) 0/1 parameter 'extinction' not found/ found
c  iover(4) 0/1 parameter 'polarity' not found/ found
c
      common/lst12/l12,m12,md12,n12,nbl12,idra,idrb,l12d,n12d,
     2	n12c,md12b,iover12(4)
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/xtemp/itemp(80)
      dimension temp(40)
      equivalence(itemp,temp)
c
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)
c
      dimension ipar(22)
      dimension iover(4)
c--
      jparg=0
      do m=1,4
       iover(m)=0
      enddo
      m=m12+3
      l=m12+md12b-1
      do ll=m,l
      istore(ll)=0
      enddo
      call par22(m,np,iover)
      do 108 nn=2,lun
      nca=nc
      if(jrca(itemp,n)) 109,103,109
103   continue
      n=kcomp(1,itemp,ipar,lun,1)
      if(n) 106,106,104
104   continue
      call par22(m,n,iover)
      go to 108
106   continue
      jparg=1
      return
108   continue
109   continue
      return
      end
c
code for par22
      subroutine par22(m,np,iover)
c--insert code
c
      dimension iover(4)
c
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)
c
      goto(1,1,1,1,1,1,1,1,1,1 ,1,1,1,1,15,16,
     2	   17,18,19,19,19,19),np
1     continue
      istore(m+np-1)=1
      goto 20
15    continue
      np=4
      goto 1
16    continue
      do i=1,3
      istore(m+i-1)=1
      enddo
      goto 20
17    continue
      do i=4,9
      istore(m+i-1)=1
      enddo
      goto 20
18    continue
      i=4
      istore(m+i-1)=1
      i=7
      istore(m+i-1)=1
      i=9
      istore(m+i-1)=1
      goto 20
19    continue
      i=np-18
      iover(i)=1
      goto 20
20    continue
      return
      end
c
code for icrea12
      function	icrea12(in,inext,ladr,nsched)
c--form default list 12
c  load the symmetry operator
c--update lista 5 for occ
c  initialize the store vector and read the lists
c--in=1/2   full/diag
c  inext  = 0 lista 12 default e basta
c	    1 chiede ulteriori direttive (standard input)
c  ladr   = indirizzo in istore delle direttive
c  nsched = numero di schede
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      icrea12=0
      call xcsae
      call xrsl
      call xfl01
      call xfl02
      call xfl03
      call srlin(5,li,lj,lk,ll,lm)
      if(lj.gt.0)then
      call xfl05
      else
      in=-in
      endif
      if(jset12(in,inext,ladr,nsched)) 1070,1000,1010
1000  continue
      call xfrm5
      call xfl05
1010  continue
      return
1070  continue
      icrea12=-1
      return
      end
c
code for jset12
      function	jset12(in,inext,ll,nsched)
c--form default list 12
c  list 1, 2, 3, 5 was read before by the calling routine
c--load the symmetry operator
c--in=1/2  full/diag
c     -1/2 lista 5 non presente
c  inext = 0 lista 12 default e basta
c	   1 ritorna per poter inserire altre direttive (standard input)
c  ll	  = indirizzo in istore delle schede (in output)
c  nsched = numero di schede
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
c--
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *	kpol,jsys,lat,indv(32),mpv(64),jspini,ddmin,ncawu,ncwuy
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),jsysx,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/rc/p(6),cx(9),dumm(9)
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icentx,latx,s3s2,emme
     *          ,s3s2p
      dimension xo(11),xn(11),key(10),newvet(48,3)
c--
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
      common/lst02/ic,il,g2,isys,ngenc,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
     3 ,l2a,l2b,l2c,l2d,l2j,noric
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori
      common/lst22/ l22,m22,md22,n22,l22a,m22a,md22a,n22a,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,l22d,m22d,md22d,n22d,
     2 iflorg,ieq,iwe,in14,iover22(4),iadov22(4)
      common/xcons/pin,twopis,twopin,rtd,dtr,xnx
c--
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)
c--
      dimension ifull(4,2),iend(4),ifxh(12),kyp(3)
      dimension irig(9,4),irign(4),irigx(4),isumc(4),ixyz(3)
      data ixyz/1hx,1hy,1hz/
      data isumc/1hs,1hu,1hm,1h /
      data ifull/1hf,1hu,1hl,1hl,
     1		 1hd,1hi,1ha,1hg/
      data iend/1he,1hn,1hd,1h /
c      data isot/1hb,1h[,1hi,1hs,1ho,1h]/
      data jjh/2hh /
      data irign/1hb,1hc,1hn,1ho/
      data irig/1hr,1hi,1hd,1he,1h ,1h ,1hb,1h ,1hh,
     1		1hr,1hi,1hd,1he,1h ,1h ,1hc,1h ,1hh,
     2		1hr,1hi,1hd,1he,1h ,1h ,1hn,1h ,1hh,
     3		1hr,1hi,1hd,1he,1h ,1h ,1ho,1h ,1hh/
      data ifxh/1hf,1hi,1hx,1h ,1hh,1h ,1hb,1h[,1hi,1hs,1ho,1h]/
c--in=1/2  full/diag
c      write(lo,*)' entro in jset12,nfl',nfl
      jset12=0
      ilist5=0
      if(in.lt.0) then
      in=iabs(in)
      ilist5=-1
      endif
      lo=ncwu
      pi=pin
      twopi=twopin
      rtod=rtd
      dtor=dtr
      m1=l1p1
      do 10 i=1,6
      cx(i)=store(m1)
      if(i.gt.3)cx(i)=cx(i)*rtd
10    m1=m1+1
c--read the atomic species
      do j=1,4
      irigx(j)=0
      enddo
      ihy=0
      ihy3=0
      m3=l3
      do 15 i=1,n3
      if(istore(m3).eq.jjh) ihy3=1
      do 20 j=1,4
      if(istore(m3).eq.irign(j)) irigx(j)=1
20    continue
15    m3=m3+md3
c--end of analysis
c--dummy vector of list 22
      l22a=nfl
      nfl=l22a+51
      in14=10
      md22a=5
      m22a=l22a
      do i = 1,in14
      istore(m22a)=1
      mmm=m22a+1
      do j=1,4
      istore(mmm)=0
      mmm=mmm+1
      enddo
      m22a=m22a+md22a
      enddo
c     call sw05(1,0)
c--crea list 12
      ll=nfl
      nf=ll+8000
      do 1000 l=ll,nf
1000  istore(l)=ib
      mm=ll
      do 1010 i=1,4
      istore(mm)=ifull(i,in)
      mm=mm+1
1010  continue
      m12=ll+80
      mm12=m12
c--load the work matricies
      latx=il
      jsysx=isys
      ngen=ngenc
      nori=noric
      icentx=ic
      icent=ic
c      msym=n2*icentx
      neqv=n2
      nsym=n2
c      if(msym.eq.1) goto 1070
      kk=l2i
      nsym2=n2*2
      do 29 i=1,nsym2
      do 29 j=1,nsym2
      irot(i,j)=istore(kk)
   29 kk=kk+1
      m2=l2
      do 40 j=1,n2
      kk=m2-1
      do 30 i=1,3
      do 31 k=1,3
      kk=kk+1
   31 kmat(j,i,k)=store(kk)
   30 continue
      do 35 i=1,3
      kk=kk+1
   35 tmat(j,i)=store(kk)
      m2=m2+md2
   40 continue
      call xspinb
      if(ilist5.lt.0) goto 2001
      m5=l5
      do 2000 i=1,n5
      do 1999 ii=1,11
      xo(ii)=0
1999  xn(ii)=0
      itype=istore(m5)
      m5h=m5+13
      iser=i
c     khead=0
c     iactn=3
      khead=1
      iactn=2
c      write(ncwu,'(a,a2,i5)')'icrea12',istore(m5),ihy
      if(istore(m5).eq.jjh)ihy=1
      xo(1)=store(m5+2)
      xo(2)=store(m5+3)
      xo(3)=store(m5+4)
      xo(4)=store(m5+11)
      do  ii=5,10
      xo(ii)=store(m5+ii)
      enddo
c      write(ncwu,2046)itype,xo(1),xo(2),xo(3),xo(4)
c      write(ncwu,2046)itype,xo
      ks=kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
c      x(4,i)=1.0/float(key(10))
c      write(ncwu,2046)itype,xn(1),xn(2),xn(3),xn(4),xn(11)
c      write(ncwu,2047)key
c--control the floating origen
c      if(kpol.ge.1.and.i.eq.1)then
c	ky3=mod(kpol,10)
c	ky2=mod(kpol,100)/10
c	ky1=kpol/100
cc	write(ncwu,*)' kpol,ky1,ky2,ky3 ',kpol,ky1,ky2,ky3
c	if(key(3).eq.3.and.ky3.eq.1)key(3)=0
c	if(key(2).eq.2.and.ky2.eq.1)key(2)=0
c	if(key(1).eq.1.and.ky1.eq.1)key(1)=0
c      endif
c      write(ncwu,2047)key
c      write(ncwu,2046)itype,xn
c      write(ncwu,2047)key
c      if (key(10).gt.1) then
      if (key(10).ge.1) then
         call site(newvet,key,1,ks)
	 m22a=l22a
c	  write(ncwu,2047)key
	 ic12=0
	 call readkey(ic12,key,mm12,ier)
c	  do k=1,3
c	   x(k,i)=xn(k)
c	  enddo
         endif
      store(m5+2)=xn(1)
      store(m5+3)=xn(2)
      store(m5+4)=xn(3)
      if(store(m5+32).le.0.001) then
       if(store(m5+11).ge.0.98) then
        store(m5+11)=xn(11)
       endif
      endif
      do ii=5,10
       store(m5+ii)=xn(ii)
      enddo
2000  m5=m5+md5
2046  format(1x,a4,5f10.4,/,6f10.4)
2047  format(1x,' crea key ',10i6)
2048  format(1x,80a1)
c--control the floating origen
2001  continue
      if(kpol.ge.1)then
      kyp(3)=mod(kpol,10)
      kyp(2)=mod(kpol,100)/10
      kyp(1)=kpol/100
c	write(ncwu,*)' kpol,ky1,ky2,ky3 ',kpol,kyp
c--insert the 'sum ' directives  (restraint)
      do n=1,3
       if(kyp(n).ne.0) then
	 m12=mm12
	 mm12=m12
	 do l=1,80
	  istore(mm12)=ib
	  mm12=mm12+1
	 enddo
	 mm=m12
	 do i=1,4
	  istore(mm)=isumc(i)
	  mm=mm+1
	 enddo
	 mm=mm+2
	 istore(mm)=ixyz(n)
	 m12=m12+80
	 mm12=m12
       endif
      enddo
      endif
      if(ihy.eq.0)go to 3999
c--insert the 'ride' directives
      m12=mm12
      do 3100 j=1,4
      if(irigx(j).eq.0) goto 3100
      mm12=m12
      do 3000 l=1,80
      istore(mm12)=ib
3000  mm12=mm12+1
      mm=m12    
      do 3010 i=1,9
      istore(mm)=irig(i,j)
3010  mm=mm+1
      m12=m12+80
3100  continue
      mm12=m12
      do 3400 l=1,80
      istore(mm12)=ib
3400  mm12=mm12+1
      mm=m12    
      do 3410 i=1,12
      istore(mm)=ifxh(i)
3410  mm=mm+1
      m12=m12+80
3999  continue
      m12=mm12
      if(inext.eq.0) then
       do l=1,80
	istore(mm12)=ib
       mm12=mm12+1
       enddo
       mm=m12
       do i=1,4
	istore(mm)=iend(i)
	mm=mm+1
       enddo
      endif
c      write(ncwu,*)' ll,mm12',ll,mm12
c      write(ncwu,*)' jset12: stampo l12 '
c      write(ncwu,2048)(istore(im),im=ll,mm12-1)
      nsched= (mm12-ll+1)/80
c      write(ncwu,*) ' nsched = ',nsched
      nfl=mm12+1
      if(inext.eq.0) then
       if(j12y(ll,nsched).lt.0)go to 1070
c      in=1
c      call sw12(in)
      endif
      if(ilist5.lt.0) then
       jset12=1
      endif
c      write(lo,*)' esco da icrea12,nfl',nfl
      return
1070  continue
      jset12=-1
      return
      end
c
code for idef12
      function 	idef12(in)
c--set s.g. conditions for list 12
c  lists (12 and 22 also) was read before from the calling routine
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcard/nch,image(80),nc,nd,ni,ntt,na(3),ncd,idoc(20)
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint 
c--
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *	       kpol,jsys,lat,indv(32),mpv(64),jspini,ddmin,ncawu,ncwuy
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),jsysx,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/rc/p(6),cx(9),dumm(9)
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icentx,latx,s3s2,emme
     *          ,s3s2p
      dimension xo(11),xn(11),key(10),newvet(48,3)
c--
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
      common/lst02/ic,il,g2,isys,ngenc,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
     3 ,l2a,l2b,l2c,l2d,l2j,noric
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori
      common/lst12/l12,m12,md12,n12,nbl12,idra,idrb,l12d,n12d,
     2	n12c,md12b,iover12(4)
      common/lst22/ l22,m22,md22,n22,l22a,m22a,md22a,n22a,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,l22d,m22d,md22d,n22d,
     2 iflorg,ieq,iwe,in14,iover22(4),iadov22(4)
      common/xcons/pin,twopis,twopin,rtd,dtr,xnx
      common/xtemp/itemp(80)
      dimension temp(40)
      equivalence(itemp,temp)
c--
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)
c--
      character*8 name1,name2
c      dimension ioc(3),isot(6)
      dimension jjh(1)
      dimension itarg(4),ihflg(2)
      dimension iend(4),ifxh(12),isumx(3),kyp(3)
      dimension irig(9,4),irign(4),irigx(4),isumc(4),ixyz(3)
      data ixyz/1hx,1hy,1hz/
      data isumc/1hs,1hu,1hm,1h /
c      data ioc/1ho,1hc,1hc/
      data iend/1he,1hn,1hd,1h /
c      data isot/1hb,1h[,1hi,1hs,1ho,1h]/
      data jjh/2hh /
      data irign/1hb,1hc,1hn,1ho/
      data irig/1hr,1hi,1hd,1he,1h ,1h ,1hb,1h ,1hh,
     1          1hr,1hi,1hd,1he,1h ,1h ,1hc,1h ,1hh,
     2          1hr,1hi,1hd,1he,1h ,1h ,1hn,1h ,1hh,
     3          1hr,1hi,1hd,1he,1h ,1h ,1ho,1h ,1hh/
      data ifxh/1hf,1hi,1hx,1h ,1hh,1h ,1hb,1h[,1hi,1hs,1ho,1h]/
      data itarg/4hfix ,
     1		 4hride,
     2		 4hequi,
     3		 4hsum /
c--
c      write(ncwu,*)'entro in idef12'
      idef12=0
      lo=ncwu
      pi=pin
      twopi=twopin
      rtod=rtd
      dtor=dtr
      m1=l1p1
      do i=1,6
      cx(i)=store(m1)
      if(i.gt.3)cx(i)=cx(i)*rtd
      m1=m1+1
      enddo
c--read the atomic species
      do j=1,4
      irigx(j)=0
      enddo
      isumy=0
      do j=1,3
      isumx(j)=0
      enddo
      ihy=0
      ihy3=0
      m3=l3
      do 15 i=1,n3
      if(istore(m3).eq.jjh(1)) ihy3=1
      do j=1,4
      if(istore(m3).eq.irign(j)) irigx(j)=1
      enddo
15    m3=m3+md3
c--check if H atoms are present in list 5
      ihy2=0
      m5=l5
      do 1010 i=1,n5
      if(istore(m5).eq.jjh(1)) ihy2=1 
      m5=m5+md5
1010  continue
c--end of analysis
c--save m12 address
      m12x=m12
c--define room for 1000 directives...
      nmaxdir=1000
      ll=nfl
      ll1=ll+80000
1014  continue
      if(ll1.lt.lfl) goto 1015
      ll1=ll1-80
      nmaxdir=nmaxdir-1
      goto 1014
c--deve essere introdotto il controllo su nmaxdir
c      write(ncwu,*) 'nfl,ll,ll1,lfl:',nfl,ll,ll1,lfl
1015  continue
      do 1000 l=ll,ll1
1000  istore(l)=ib
      m12=l12
      mm12=ll
c      write(*,*)' ll=',ll
c--loop sulle n12-1 direttive presenti in lista 12
      ihflg(1)=0
      ihflg(2)=0
      nn12=0
      do l=1,n12-1
      m=m12+md12b
	do i=1,80
	 istore(mm12)=istore(m)
	 image(i)=istore(m)
	 m=m+1
	 mm12=mm12+1
	enddo
c--check tipo di direttiva presente
      nc=1
      kk=jrca(itemp,n)
      in=kcomp(1,itemp,itarg,4,1)
      if(in.eq.4) then
       isumy=1
       in=0
      endif
c      write(ncwu,*) 'old dir',in
      if(in.ge.1) then
c--direttiva tipo 'fix h ...' or 'ride x h ...' or 'equiv h(1)...'
       kk=jrcx(itemp,n,id,4)
       if(in.eq.2) kk=jrca(itemp,n)
       inn=kcomp(1,itemp,jjh,1,1)
       if (inn.eq.1) then
          if(ihy2.eq.0) goto 1020 
          if(in.eq.3) in=2
          ihflg(in)=1 
      end if
      end if
      nn12=nn12+1
c      write(*,*)' n. card:',nn12
c      write(*,'(80a1)')image
      m12=m12+md12
1020  continue
      enddo
c--fine loop sulle direttive presenti
c      write(ncwu,*)'idef12,ihy2,ihy,ihflg(1),ihflg(2)',
c     1  ihy2,ihy,ihflg(1),ihflg(2)
c      m12=mm12
      mm12=ll+80*nn12
c      write(*,*)' mm12=',mm12
c      n12=nn12+1
c--load the work matricies
      latx=il
      jsysx=isys
      ngen=ngenc
      nori=noric
      icent=ic
      icentx=ic
c      msym=n2*icentx
      neqv=n2
      nsym=n2
c      if(msym.eq.1) goto 1070
      kk=l2i
      nsym2=n2*2
      do 29 i=1,nsym2
      do 29 j=1,nsym2
      irot(i,j)=istore(kk)
   29 kk=kk+1
      m2=l2
      do 40 j=1,n2
      kk=m2-1
      do 30 i=1,3
      do 31 k=1,3
      kk=kk+1
   31 kmat(j,i,k)=store(kk)
   30 continue
      do 35 i=1,3
      kk=kk+1
   35 tmat(j,i)=store(kk)
      m2=m2+md2
   40 continue
      call xspinb
c      write(ncwu,*)'dopo xspinb'
c--check if floating origin is present
      if (kpol.ne.0) then
	kyp(3)=mod(kpol,10)
	kyp(2)=mod(kpol,100)/10
	kyp(1)=kpol/100
c	write(ncwu,*)' kpol,ky1,ky2,ky3 ',kpol,kyp
c--check if the directive 'sum ' is present (restraint)
	if(isumy.eq.1) then
c--check if the parameter is for the floating origin
	m22d=l22d
	do jy=1,n22d
	if(istore(m22d).eq.4) then
	 nn=istore(m22d+5)
	 m=m22d+7
	 do n=1,nn
	  nn=istore(m)
	  do i=1,3
	   if(kyp(i).eq.1.and.nn.eq.i) isumx(i)=1
	  enddo
	  m=m+1
	 enddo
	endif
	m22d=m22d+istore(m22d+1)
	enddo
	endif
      end if
c--end of floatin origin check
2185  continue
      m5=l5
      m22=l22
      do 2000 i=1,n5
c      write(ncwu,*) 'istore(m22), i=',istore(m22),i
      if(istore(m22)) 2100,2100,2050
2050  continue
      m22a=m22+1
      do ii=1,11
      xo(ii)=0
      xn(ii)=0
      enddo
      itype=istore(m5)
      iser=i
c     khead=0
c     iactn=3
      khead=1
      iactn=2
      xo(1)=store(m5+2)
      xo(2)=store(m5+3)
      xo(3)=store(m5+4)
      xo(4)=store(m5+11)
      do 2001 ii=5,11
2001  xo(ii)=store(m5+ii)
c      write(ncwu,2046)itype,xo(1),xo(2),xo(3),xo(4)
c      write(ncwu,2046)itype,xo
      ks=kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
c      x(4,i)=1.0/float(key(10))
c      write(ncwu,2046)itype,xn(1),xn(2),xn(3),xn(4),xn(11)
c      write(ncwu,2047)key
c--control the floating origen
c      if(kpol.ge.1.and.i.eq.1)then
c	write(ncwu,*)' kpol,ky1,ky2,ky3 ',kpol,ky1,ky2,ky3
c	if(key(3).eq.3.and.ky3.eq.1)key(3)=0
c	if(key(2).eq.2.and.ky2.eq.1)key(2)=0
c	if(key(1).eq.1.and.ky1.eq.1)key(1)=0
c      endif
c      write(ncwu,2047)key
c      write(ncwu,2046)itype,xn
c      write(ncwu,2047)key
c      if (key(10).gt.1) then
      if (key(10).ge.1) then
         call site(newvet,key,1,ks)
c	 write(ncwu,2047)key
	 mm12y=mm12
         ic12=1
	 call readkey(ic12,key,mm12,ier)
	 if(ier.ne.0) then
c--delete precedenti direttive Fix , Equiv , Factor
c  con il nome del corrente atomo
	  nsched= (mm12y-ll+1)/80
	  m5h=m5+13
	  name2=' '
	  write(name2,'(2a4)')(istore(n),n=m5h,m5h+1)
c          write(ncwu,*)'ll,ier,nsched,name2',ll,ier,nsched,name2
c	  call xdel12(name2,ll,nsched,ier)
c          write(ncwu,*)'ll,ier,nsched,name2',ll,ier,nsched,name2
	  mm12=ll+80*nsched
          m22ax=m22a
          iblo=0
          do k=1,3
           if(istore(m22ax).gt.iblo) iblo=istore(m22ax)
           m22ax=m22ax+md22a
          enddo
          m22ax=m22a
          do k=1,3
           istore(m22ax)=iblo
           m22ax=m22ax+md22a
          enddo
          if(store(m5+10).gt.0.0) then
           m22ax=m22a+3*md22a
           iblo=0
           do k=1,6 
           if(istore(m22ax).gt.iblo) iblo=istore(m22ax)
           m22ax=m22ax+md22a
          enddo
          m22ax=m22a+3*md22a
          do k=1,6
           istore(m22ax)=iblo
           m22ax=m22ax+md22a
          enddo
          endif
          ic12=0
	  call readkey(ic12,key,mm12,ier)
	 endif
c	  do k=1,3
c	   x(k,i)=xn(k)
c	  enddo
      endif
c--aggiorno la lista 5
      store(m5+2)=xn(1)
      store(m5+3)=xn(2)
      store(m5+4)=xn(3)
      store(m5+11)=xn(11)
      do ii=5,11
      store(m5+ii)=xn(ii)
      enddo
c-------------------------------
2100  continue
      m22=m22+md22
      m5=m5+md5
2000  continue
2046  format(1x,a4,5f10.4,/,6f10.4)
2047  format(1x,' idef12(key) ',10i6)
2048  format(1x,80a1)
c      write(ncwu,*)'idef12(a),ihy2,ihy,ihflg(1),ihflg(2)',
c     1	 ihy2,ihy,ihflg(1),ihflg(2)
c--control the floating origen
      if(kpol.ne.0) then
c--insert the 'sum ' directives  (restraint)
       do n=1,3
       if(isumx(n).eq.0.and.kyp(n).ne.0) then
	m12=mm12
	mm12=m12
	do l=1,80
	 istore(mm12)=ib
	 mm12=mm12+1
	enddo
	mm=m12
	do i=1,4
	 istore(mm)=isumc(i)
	 mm=mm+1
	enddo
	mm=mm+2
	istore(mm)=ixyz(n)
	m12=m12+80
	mm12=m12
	endif
	enddo
      endif
      if(ihy2.eq.0)go to 3999
c--insert the 'ride' directives for the h atom(s)
      m12=mm12
      if(ihflg(2).eq.0) then
	 do 3100 j=1,4
c	 write(6,*)'irigx:',irigx(j)
	 if(irigx(j).eq.0) goto 3100
	 mm12=m12
	 do 3000 l=1,80
	 istore(mm12)=ib
3000	 mm12=mm12+1
	 mm=m12
	 do 3010 i=1,9
	 istore(mm)=irig(i,j)
3010	 mm=mm+1
	 m12=m12+80
3100	 continue
      endif
      if(ihflg(1).eq.0) then
         mm12=m12
	 do 3400 l=1,80
	 istore(mm12)=ib
3400	 mm12=mm12+1
	 mm=m12
	 do 3410 i=1,12
	 istore(mm)=ifxh(i)
3410	 mm=mm+1
	 m12=m12+80
      endif
3999  m12=mm12
c--insert the 'end ' directive
      do 4000 l=1,80
      istore(mm12)=ib
4000  mm12=mm12+1
      mm=m12    
      do 4010 i=1,4
      istore(mm)=iend(i)
4010  mm=mm+1
c      write(ncwu,*)' ll,mm12',ll,mm12
c      write(ncwu,*)' idef12: stampo l12 '
c      write(ncwu,2048)(istore(im),im=ll,mm12-1)
      nsched= (mm12-ll+1)/80
c      write(ncwu,*) ' nsched = ',nsched
      nfl=mm12+1
c--reset m12 address
c      m12=m12x
      if(j12y(ll,nsched).lt.0)go to 1070
c      in=1
c      call sw12(in)
c      write(lo,*)' fine idef12,nfl',nfl
      return
1070  continue
      idef12=-1
      return
      end
c
code for readkey 
      subroutine readkey(ic12,key,mm2,ier)
c
      common/xfour/ itype,iprint,numero,iweigx,il  ,im	,iv  ,isogl
     2 ,ihomx,ihvmx,ihsmx,rvol,scale,f000,scr,isearc,n5p,inte,iref
c
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
      common/lst02/ic,ill,g2,isys,ngenc,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
     3 ,l2a,l2b,l2c,l2d,l2j,noric
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori
      common/lst12/l12,m12,md12,n12,nbl12,idra,idrb,l12d,n12d,
     2	n12c,md12b,iover12(4)
      common/lst22/ l22,m22,md22,n22,l22a,m22a,md22a,n22a,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,l22d,m22d,md22d,n22d,
     2 iflorg,ieq,iwe,in14,iover22(4),iadov22(4)
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
c
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xnclu/ncmu,nctu,ncau,ncsu,nclg,nccf
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c      character*60 iiscr,jjscr
      character*60  jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
      common/xscru/ jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8)
      dimension cod(30)
      equivalence(icod,cod)
      common/workb/ja,idumb(25)
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
c
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)
c--
      dimension kFix(5),iequi(5),iweig(5),ixy(3),ixz(3),iyz(3)
      dimension ixyz(3),iorder(6),iparx(6)
      dimension ibij(12),jweig(3),key(10)
      data  kFix/1hf,1hi,1hx,1h ,1h /
      data iequi/1he,1hq,1hu,1hi,1h /
      data iweig/1hf,1ha,1hc,1ht,1h /
      data ixyz/1hx,1hy,1hz/
      data ixy /1hx,1h ,1hy/,iyz/1hy,1h ,1hz/,ixz/1hx,1h ,1hz/
      data ibij/1h1,1h1,1h2,1h2,1h3,1h3,1h2,1h3,1h1,1h3,1h1,1h2/
c--
c--analysis on positional parameters
c--   jfix=1 no cond. jfix=2 fix x    jfix=4 fix y    jfix=6  fix z
c--   jfix=5 fix x y  jfix=7 fix x z  jfix=9 fix y z  jfix=10 fix x y z
c--
c--   jequiv=1 no cond.    jequiv=5  equiv x y  
c--   jequiv=7 equiv x z   jequiv=9  equiv y z  
c--   jequiv=10 equiv x y and equiv x z
c
      ier=0
      mm22=mm2
      jfix=1
      jequiv=1
      m22ax=m22a
      if(ic12.eq.1) then
c--controllo che almeno un parametro posizionale e' da affinare
      kpar=0
      do i=1,3
      kpar=kpar+iabs(istore(m22a))
      m22a=m22a+md22a
      enddo
      if(kpar.eq.0) goto 4200
      m22a=m22ax
c--controllo che key(i) e istore(m22a...) siano uguali...
      do i=1,3
      if(key(i).ne.0) then
	 if(istore(m22a).eq.0) goto 9000
       else
	 if(istore(m22a).ne.0) goto 9000
      endif
      m22a=m22a+md22a
      enddo
      m22a=m22ax
      endif
c--controllo condizioni
      jfix=1
      jequiv=1
      do 100 i=1,3
c      write(6,*) 'istore(m22a),i=',istore(m22a),i
      if(istore(m22a).le.0) goto 110
      jweig(i)=1
      if(key(i).eq.0)then
	jfix=jfix+2*i-1
      else
	if(key(i).lt.0)jweig(i)=-1
	kei=key(i)*jweig(i)
	if(kei.gt.10)then
	  jweig(i)=jweig(i)*(kei/10)
	  kei=kei-iabs(jweig(i)*10)
	endif
	if(kei.ne.i)jequiv=jequiv+2*kei+2*i-2
      endif
110   continue
      m22a=m22a+md22a
100   continue
c      write(ncwu,*)' jfix,jequiv,jweig ',jfix,jequiv,jweig 
      if(jequiv.eq.11)jequiv=10
      if(jfix.eq.1)go to 3002
c--fix
      call  instr12(kFix,jb)
c------------1	   2	3   4	 5    6    7	8    9	  10----------
      go to(3002,1200,3002,1100,1200,1300,1200,3002,1100,1200),jfix
1100  continue
      itemp(jb)=ixyz(2)
      jb=jb+2
      if(jfix.eq.9)itemp(jb)=ixyz(3)
      go to 3000 
1200  continue
      itemp(jb)=ixyz(1)
      jb=jb+2
      if(jfix.eq.5.or.jfix.eq.10)itemp(jb)=ixyz(2)
      jb=jb+2
      if(jfix.eq.7.or.jfix.eq.10)itemp(jb)=ixyz(3)
      go to 3000
1300  itemp(jb)=ixyz(3)
3000  continue
      do i=1,80
	istore(mm2)=itemp(i)
	mm2=mm2+1
      enddo
c--equiv
3002  continue
      jequiv=jequiv-4
      inser=0
      if(jequiv.lt.0)go to 4200
c------------1	  2    3    4	 5    6-------------
      go to(3100,4200,3300,4200,3500,3100),jequiv
3100  continue
      mmm=m22ax+4
      if(istore(mmm).gt.0)goto 3112 
      mmm=m22ax+md22a+4
      if(istore(mmm).gt.0)goto 3112 
      inser=1
      call  instr12(iequi,jb)
      do 3110 i=1,3
      itemp(jb)=ixy(i)
3110  jb=jb+1
      jb=jb+1
3112  continue      
      if(jequiv.eq.1)go to 4000
      if(inser.eq.0) goto 3113
      do 3111 i=1,80
      istore(mm2)=itemp(i)
3111  mm2=mm2+1
3113  continue
      mmm=m22ax+2*md22a+4
      if(istore(mmm).gt.0)goto 4011 
      call  instr12(iequi,jb)
      do 3130 i=1,3
      itemp(jb)=ixz(i)
3130  jb=jb+1
      jb=jb+1
      go to 4000
3300  continue
      mmm=m22ax+4
      if(istore(mmm).gt.0)goto 4011 
      mmm=m22ax+2*md22a+4
      if(istore(mmm).gt.0)goto 4011 
      inser=1
      call  instr12(iequi,jb)
      do 3310 i=1,3
      itemp(jb)=ixz(i)
3310  jb=jb+1
      jb=jb+1
      go to 4000
3500  continue
      mmm=m22ax+md22a+4
      if(istore(mmm).gt.0)goto 4011 
      mmm=m22ax+2*md22a+4
      if(istore(mmm).gt.0)goto 4011 
      inser=1
      call  instr12(iequi,jb)
      do 3510 i=1,3
      itemp(jb)=iyz(i)
3510  jb=jb+1
      jb=jb+1
      go to 4000
4000  continue
      if(inser.eq.0) goto 4011
      do 4001 i=1,80
      istore(mm2)=itemp(i)
4001  mm2=mm2+1
4011  continue
      if(inser.eq.0) goto 4200
c--and joined weight
      do 4100 j=1,3
      if(jweig(j).eq.1)go to 4100
      call instr12(iweig,jb)
      jb=jb+1
      itemp(jb)=ixyz(j)
      jb=jb+3
      if(jweig(j).lt.0)itemp(jb)=inus
      jb=jb+1
      itemp(jb)=numb(iabs(jweig(j))+1)
      itemp(jb+1)=ipoint
      jb=jb+3
      do 4211 i=1,80
      istore(mm2)=itemp(i)
4211  mm2=mm2+1
c      write(*,*)'ww',itemp
4100  continue
c
c--analysis on anisotropic parameters
4200  continue
c      write(6,*)'store(m5+10)',store(m5+10)
      if(store(m5+10).le.0.0) go to 5200
c--change the code for 23 13 12 if they are equivalenced 
      inc=0
      do j=7,9
      keyc=iabs(key(j))
      if(keyc.eq.7)  inc=inc+1
      enddo
c      write(ncwu,*)'inc:',inc
      if(inc.eq.3) then
c	 write(ncwu,2047)key
c2047    format(1x,'prima key*',10i6)
	isig=isign(1,key(9))
        do 4220 j=7,9
        isig1=isign(1,key(j))
        key(j)=9*isig*isig1
4220    continue
c	 write(ncwu,2048)key
c2048	 format(1x,' dopo key*',10i6)
      endif
c--change the order of code
c  b(11)
      iorder(1)=istore(m22a)
      iparx(1)=istore(m22a+4)
      m22a=m22a+md22a
c  b(12)
      iorder(6)=istore(m22a)
      iparx(6)=istore(m22a+4)
      m22a=m22a+md22a
c  b(13)
      iorder(5)=istore(m22a)
      iparx(5)=istore(m22a+4)
      m22a=m22a+md22a
c  b(22)
      iorder(2)=istore(m22a)
      iparx(2)=istore(m22a+4)
      m22a=m22a+md22a
c  b(23)
      iorder(4)=istore(m22a)
      iparx(4)=istore(m22a+4)
      m22a=m22a+md22a
c  b(33)
      iorder(3)=istore(m22a)
      iparx(3)=istore(m22a+4)
c--fix
      kinst=0
      do 5001 j=1,6
      if(iorder(j).le.0) goto 5001
      if(key(j+3).eq.0)then
	iorder(j)=0
	call instr12(kFix,jb)
	kinst=1
	ij=2*j-1
	jb=jb+1
	itemp(jb)=ibij(ij)
	itemp(jb+1)=ibij(ij+1)
	jb=jb+3
	do 5011 i=1,80
	istore(mm2)=itemp(i)
5011	mm2=mm2+1
      endif
5001  continue
      if(kinst.eq.0) goto 5100
c--equiv
5100  continue
      kinst=0
      kweigh=0
      do 5101 j=4,9
      if(iorder(j-3).le.0) goto 5101
      keyc=iabs(key(j))
      if(keyc.ne.j)then
	jj=keyc
        if(jj.ge.10.or.key(j).lt.0) kweigh=1
        if(jj.ge.10) then
          jjj=jj/10
          jj=jj-jjj*10
        end if
        if(jj.ne.j) then
          if(iparx(jj-3).ne.0.or.iparx(j-3).ne.0) goto 5101 
	  call instr12(iequi,jb)
	  kinst=1
	  jb=jb+3
	  ij=2*(jj-3)-1
	  itemp(jb)=ibij(ij)
	  itemp(jb+1)=ibij(ij+1)
	  jb=jb+3
	  ij=2*(j-3)-1
	  itemp(jb)=ibij(ij)
	  itemp(jb+1)=ibij(ij+1)
	  jb=jb+3
c          write(ncwu,'(a,80a1)') 'rdk: ',itemp
	  do i=1,80
           istore(mm2)=itemp(i)
	   mm2=mm2+1
          enddo
        endif
      endif
5101  continue
      if(kinst.eq.0) goto 5200
c--weight --> factor
      if(kweigh.eq.0)go to 5200
      do 5102 j=4,9
      if(iorder(j-3).le.0) goto 5102
      keyc=iabs(key(j))
      if(keyc.ne.j)then
	jj=keyc
        kweigh=1
        if(key(j).lt.0) kweigh=-1
	if(jj.gt.10) then
          kweigh=kweigh*(keyc/10)
	  jjj=jj/10
          jj=jj-jjj*10
	end if
       if(kweigh.ne.1) then
	  call instr12(iweig,jb)
	  jb=jb+3
	  ij=2*(j-3)-1
c--	    ij=2*(jj-3)-1
	  itemp(jb)=ibij(ij)
	  itemp(jb+1)=ibij(ij+1)
	  jb=jb+3
          if(kweigh.lt.0) itemp(jb)=inus
          jb=jb+1
	  itemp(jb)=numb(iabs(kweigh)+1)
	  itemp(jb+1)=ipoint
	  do 5121 i=1,80
	  istore(mm2)=itemp(i)
5121	  mm2=mm2+1
        end if
      endif
5102  continue
5200  continue
c      write(ncwu,*)' readkey in output: '
c      write(ncwu,4005)(istore(ii),ii=mm22,mm2-1)
4005  format(1x,80a1)
      return
9000  continue
      ier=-1
      return
      end
c
code for instr12
      subroutine instr12(instr,jb)
c--
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
c
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)
      dimension instr(5),iname(16)
      character*20 ifmt
c--
      m5h=m5+13
      write(ifmt,'(2a4)')(istore(m),m=m5h,m5h+1)
      read(ifmt,'(16a1)')(iname(m),m=1,8)
c      write(*,'(2a4)')(istore(m),m=m5h,m5h+1)
      jb=1
      do i=1,80
      itemp(i)=ib
      enddo
      do i=1,5
      itemp(jb)=instr(i)
      jb=jb+1
      enddo
      jb=jb+1
      do i=1,8
      itemp(jb)=iname(i)
      jb=jb+1
      enddo
      jb=jb+1
c      write(ncwu,*)' stampo itemp '
c      write(ncwu,4005)(itemp(ii),ii=1,80)
4005  format(1x,80a1)
      return
      end
c
code for sw12                                                           
      subroutine sw12(in)
c--print list 12
c  in=0 call from directive
c     1 call from program
c                                                                       
      common/lst02/icc,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c
      common/lst12/l12,m12,md12,n12,nbl12,idra,idrb,l12d,n12d,
     2	n12c,md12b,iover12(4)
      common/lst22/ l22,m22,md22,n22,l22a,m22a,md22a,n22a,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,l22d,m22d,md22d,n22d,
     2 iflorg,ieq,iwe,in14,iover22(4),iadov22(4)
c
      character*80 ifmt
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcard/nch,image(80),idm(3),nt,na(3),ncd,idoc(20),irs(4)
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/xtemp/itemp(80)
      dimension temp(40)
      equivalence(itemp,temp)
c                                                                       
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore) 
      dimension hl(12)
      data iverb/4hverb/
c--
      ka=12                                                             
      if(kprth(ka)) 900,910,910                                         
900   continue                                                          
      call xline                                                        
      return                                                            
920   continue
      call xerr
      return
910   continue                                                          
      icodx=0
      if(in.eq.0) then
      if(jrca(itemp,n)) 1030,1015,1030
1015  continue
      if(kcomp(1,itemp,iverb,1,1)) 1030,1030,1020
1020  continue
      icodx=1
1030  continue
      endif
      call sfl12                                                        
      write(ncwu,1010) n12                                              
1010  format(' Directives for the refinement',i5)
      if(nbl12.lt.0) then
       write(ncwu,1012)
1012   format(' No. of block(s) equal no. of atom(s) plus one')
      else
       write(ncwu,1011) nbl12
1011   format(' No. of block(s)',14x,i5)
      end if
      write(ncwu,1014) n12c
1014  format(' No. di restraint(s)',10x,i5,/)
      m12=l12
      do 1000 k=1,n12
      m=m12+md12b
      m1=m+79
      i=1                                                               
      do 1025 n=m,m1                                                
      image(i)=istore(n)                                                  
      i=i+1                                                             
1025  continue         
      write(ifmt,1051)image
1051  format(80a1)
      call xcase(ifmt)
      read(ifmt,1051) image                                                 
      i=1                                                               
      do n=m,m1
       istore(n)=image(i)
       i=i+1
      enddo
      mm=kneb(80,ib,1)
      if(mm.gt.0)then
      write(ncwu,1005) k, (image(l),l=1,mm)
1005  format(1x,i5,' : ',80a1)
      endif
      m12=m12+md12
1000  continue
      if(icodx.eq.0) goto 900
      call xfl01
      call xfl02
      l2p=nfl
      call xlat(hl)
      nfl=nfl+n2p*md2p
      l=n2p*3
      m2p=l2p
      do i=1,l
      store(m2p)=hl(i)
      m2p=m2p+1
      enddo
      call xfl05
      if(jfr22(in)) 920,1100,1100
1100  continue
      call sfl22 
      call prt22
      goto 900
      end
c
code for chk12
      subroutine chk12(ier)
c--list 3,5 e 12 sono gia' state lette
c
c      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori
      common/lst12/l12,m12,md12,n12,nbl12,idra,idrb,l12d,n12d,
     2	n12c,md12b,iover12(4)
      common/ylimi/nfl,lfl,nlx,idumy(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xcard/nch,image(80),nc,nd,ni,ntt,na(3),ncd,idoc(20),irs(4)
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint 
      common/xtemp/itemp(80)
      dimension temp(40)
      equivalence(itemp,temp)
c--
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)
c
      dimension itarg(6),ihflg(2)
      dimension iend(4),ifxh(12)
      dimension irig(9,4),irign(4),irigx(4),jjh(1)
      data jjh/2hh /
      data irign/1hb,1hc,1hn,1ho/
      data irig/1hr,1hi,1hd,1he,1h ,1h ,1hb,1h ,1hh,
     1          1hr,1hi,1hd,1he,1h ,1h ,1hc,1h ,1hh,
     2          1hr,1hi,1hd,1he,1h ,1h ,1hn,1h ,1hh,
     3          1hr,1hi,1hd,1he,1h ,1h ,1ho,1h ,1hh/
      data ifxh/1hf,1hi,1hx,1h ,1hh,1h ,1hb,1h[,1hi,1hs,1ho,1h]/
      data iend/1he,1hn,1hd,1h /
      data itarg/2hfi,2hx ,
     1		 2hri,2hde,
     2           2heq,2hui/
c
c--define variable caos
      nflsav=nfl
c      istat2=0
c      ncru=ln
c      ncwu=lo
      ier=0
c--read the atomic species
      do j=1,4
      irigx(j)=0
      enddo
      ihy=0
      ihy3=0
      m3=l3
      do 15 i=1,n3
      if(istore(m3).eq.jjh(1)) ihy3=1
      do 20 j=1,4
      if(istore(m3).eq.irign(j)) irigx(j)=1
20    continue
15    m3=m3+md3
c--check if H atoms are present in list 5
      ihy2=0
      m5=l5
      do 1010 i=1,n5
      if(istore(m5).eq.jjh(1)) ihy2=1
      m5=m5+md5
1010  continue
c--end of analysis
c--define room for 1000 directives...
      ll=nfl
      ll1=ll+80000
c      write(*,*) 'nfl,ll,ll1,lfl:',nfl,ll,ll1,lfl 
      do 1000 l=ll,ll1
1000  istore(l)=ib
      m12=l12
      mm12=ll
c--loop sulle n12-1 direttive presenti in lista 12
      ihflg(1)=0
      ihflg(2)=0
      nn12=0
      do l=1,n12-1
      m=m12+md12b
        do i=1,80
         istore(mm12)=istore(m)
         image(i)=istore(m)
         m=m+1
         mm12=mm12+1
        enddo
c--check tipo di direttiva presente
      nc=1
      kk=jrca(itemp,n)
      in=kcomp(2,itemp,itarg,3,2)
c      write(*,*) 'old dir',in
      if(in.ge.1) then
c--direttiva tipo 'fix h ...' or 'ride x h ...' or  'equiv h(1)...'
       kk=jrcx(itemp,n,id,4)
       if(in.eq.2) kk=jrca(itemp,n)
       inn=kcomp(1,itemp,jjh,1,1)
       if (inn.eq.1) then
          if(ihy2.eq.0) goto 1020 
          if(in.eq.3) in=2
          ihflg(in)=1 
      end if
      end if
      nn12=nn12+1
      m12=m12+md12
1020  continue
      enddo
c      mm12=ll+80*nn12
c--fine loop sulle direttive presenti
c      write(ncwu,*)'idef12,ihy2,ihy,ihflg(1),ihflg(2)',
c     1  ihy2,ihy,ihflg(1),ihflg(2)
      if(ihy2.eq.0)go to 3999
c--insert the 'ride' directives for the h atom(s)
      m12=mm12
      if(ihflg(2).eq.0) then 
c--direttiva 'ride' non era presente
	 do 3100 j=1,4
c        write(6,*)'irigx:',irigx(j)
         if(irigx(j).eq.0) goto 3100
         mm12=m12
         do 3000 l=1,80
         istore(mm12)=ib
3000     mm12=mm12+1
         mm=m12    
         do 3010 i=1,9
         istore(mm)=irig(i,j)
3010     mm=mm+1
         m12=m12+80
3100     continue
      endif
      if(ihflg(1).eq.0) then
c--diretiva 'fix' non era presente
         mm12=m12
         do 3400 l=1,80
         istore(mm12)=ib
3400     mm12=mm12+1
         mm=m12    
         do 3410 i=1,12
         istore(mm)=ifxh(i)
3410     mm=mm+1
         m12=m12+80
      endif
3999  m12=mm12
c--insert the 'end ' directive
      do 4000 l=1,80
      istore(mm12)=ib
4000  mm12=mm12+1
      mm=m12    
      do 4010 i=1,4
      istore(mm)=iend(i)
4010  mm=mm+1
c      write(ncwu,*)' ll,mm12',ll,mm12
c      write(ncwu,*)' stampo l12 '
c      write(ncwu,2048)(istore(im),im=ll,mm12-1)
      nsched= (mm12-ll+1)/80
c      write(ncwu,*) ' nsched = ',nsched
      nfl=mm12+1
      if(j12y(ll,nsched).lt.0)go to 9000
      nfl=nflsav
      call sfl12
c      in=1
c      call sw12(in)
c      write(*,*)'fine chk12'
      return
9000  continue
      ier=-1
      end
c
code for chg12
      subroutine chg12(ier)
c--list 3,5 e 12 sono gia' state lette
c
c      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori
      common/lst12/l12,m12,md12,n12,nbl12,idra,idrb,l12d,n12d,
     2	n12c,md12b,iover12(4)
      common/ylimi/nfl,lfl,nlx,idumy(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xcard/nch,image(80),nc,nd,ni,ntt,na(3),ncd,idoc(20)
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint 
      common/xtemp/itemp(80)
      dimension temp(40)
      equivalence(itemp,temp)
c--
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)
c
      dimension idiag(4)
      data idiag/1hd,1hi,1ha,1hg/
c
c--define variable caos
      nflsav=nfl
c      istat2=0
c      ncru=ln
c      ncwu=lo
      ier=0
c--define room for 1000 directives...
      ll=nfl
      ll1=ll+80000
c      write(*,*) 'nfl,ll,ll1,lfl:',nfl,ll,ll1,lfl 
      do 1000 l=ll,ll1
1000  istore(l)=ib
      m12=l12
      mm12=ll
c--loop sulle n12 direttive presenti in lista 12
      do l=1,n12
      m=m12+md12b
        mm12a=mm12
        do i=1,80
         istore(mm12)=istore(m)
         image(i)=istore(m)
         m=m+1
         mm12=mm12+1
        enddo
c--change FULL --> DIAG
      if(l.eq.1) then
         nc=1
         kk=jrca(itemp,n)
         mm=mm12a    
         do i=1,nc
           istore(mm)=ib
           mm=mm+1
         enddo
         mm=mm12a    
         do i=1,4
           istore(mm)=idiag(i)
           mm=mm+1
         enddo
      endif
      m12=m12+md12
1020  continue
      enddo
c      mm12=ll+80*n12
c--fine loop sulle direttive presenti
      nsched= (mm12-ll+1)/80
c      write(ncwu,*) ' nsched = ',nsched
      nfl=mm12+1
      if(j12y(ll,nsched).lt.0)go to 9000
      nfl=nflsav
      call sfl12
c      in=1
c      call sw12(in)
c      write(*,*)'fine chg12'
      return
9000  continue
      ier=-1
      end
c
code for prt22
      subroutine prt22
c--full printing list 12
c
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c
      common/lst12/l12,m12,md12,n12,nbl12,idra,idrb,l12d,n12d,
     2	n12c,md12b,iover12(4)
      common/lst22/ l22,m22,md22,n22,l22a,m22a,md22a,n22a,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,l22d,m22d,md22d,n22d,
     2 iflorg,ieq,iwe,in14,iover22(4),iadov22(4)
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint
      common/xtemp/itemp(80)
      dimension temp(40)
      equivalence(itemp,temp)
c                                                                       
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                         
c                                                                       
      dimension ipar(14)
      data ipar/2hx ,2hy ,2hz ,2h11,2h12,2h13,2h22,2h23,                
     1 2h33,2hoc,2ho1,2ho2,2ho3,2ho4/
      data iparb/2hb(/
c--
      write(ncwu,1050) n5
1050  format(/,' number of atom(s) :',i6,/,
     1 ' format : parameters',/,
     2 '          no. of block',/,
     3 '          weight',/,
     4 '          atom equivalent',/,
     5 '          parameter equivalent',/)
      write(ncwu,1200)
1200  format(5x,'Scale',4x,'Ob[iso]',4x,'Extinc',
     1 2x,'Polarity',/)
      l=l5o+n5o-1
      write(ncwu,1210) (store(m),m=l5o,l)
1210  format(1x,2f10.5,8f10.3)
      write(ncwu,1220) (iover22(i),i=1,n5o)
1220  format(i8,10i10)
      write(ncwu,1060)
1060  format(/,1x,5h name,2x,5h type,1x,7h serial,4x,2h x,
     1 8x,2h y,8x,2hz ,
     2 4x,11hb(iso)/(11),2x,6h b(12),4x,6h b(13), 4x,6h b(22),
     3 4x,6h b(23),4x,6h b(33),3x,4h occ/)
      m22=l22
      m5=l5
      do 1300 i=1,n5
      m5i=m5
      m5h=m5+13
      j=istore(m5i)
      iserial=nint(store(m5+1))
      l=m5+2
      lk=m5+11
      write(ncwu,1110)(istore(ll),ll=m5h,m5h+1), j,
     1 iserial,(store(m),m=l,lk)
1110  format(1x,2a4,1x,a4,i6,11f10.5)
      l=m22+1
      mmm=1+md22a*10
      lk=l+mmm-md22a
      write(ncwu,1075) (istore(m),m=l,lk,md22a)
1075  format(20x,10i10)
      l=m22+2
      do n=1,10
      temp(n)=istore(l)/1000.0
      l=l+md22a
      enddo
      write(ncwu,1130)(temp(n),n=1,10)
1130  format(20x,10f10.2)
      do n=1,40
      itemp(n)=ib
      enddo
      l=m22+4
      j=1
      do n=1,10
      if(istore(l)) 1150,1150,1141
1141  continue
      m5i=l5+(istore(l)-1)*md5
      m5h=m5i+13
      do m=m5h,m5h+1
      itemp(j)=istore(m)
      j=j+1
      enddo
      go to 1155
1150  continue
      j=j+2
1155  continue
      l=l+md22a
      enddo
      write(ncwu,1151)(itemp(j),j=1,20)
1151  format(24x,10(2x,2a4))
      l=m22+5
      do n=1,10
      itemp(n)=ib
      enddo
      do n=1,10
      if(istore(l).eq.0) goto 1180
      j=istore(l)
      itemp(n)=ipar(j)
      if(store(m5+10).eq.0.0.and.j.eq.4) itemp(n)=iparb
1180  continue
      l=l+md22a
      enddo
      write(ncwu,1190)(itemp(n),n=1,10)
1190  format(22x,10(4x,a2,4x))
c--check if there are mixed atoms
      if(store(m5+32).gt.0.01) then
      imix=nint(store(m5+32))
      m=m5+34
      do k=1,imix
      write(ncwu,1185) istore(m+k-1),store(m+4+k-1)
1185  format(10x,a4,f16.5)
      l=m22+1+md22a*(10+k-1)
      write(ncwu,1075) istore(l)
      a=istore(l+1)/1000.0
      write(ncwu,1130)a
      do n=1,2
      itemp(n)=ib
      enddo
      if(istore(l+3).gt.0)then
      m5i=l5+(istore(l+3)-1)*md5
      m5h=m5i+13
      j=1
      do m=m5h,m5h+1
      itemp(j)=istore(m)
      j=j+1
      enddo
      endif
      write(ncwu,1151)(itemp(j),j=1,2)
      itemp(1)=ib
      if(istore(l+4).gt.0) then
      j=istore(l+4)
      itemp(1)=ipar(j)
      endif
      write(ncwu,1190)itemp(1)
      enddo
      endif
      m22=m22+md22
      m5=m5+md5
1300  continue
      return
      end
c
code for sr15
      subroutine sr15
c--read list 15, peaks coordinates
c
      common/lst15/l15,m15,md15,n15
c
      integer*4 nfl,nl
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/xchar/id,ie,ib,ic,ia,ih
     1 ,numb(10),iplus, inus,ipoint                    
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/xtemp/itemp(80)
      dimension temp(40)
      equivalence(itemp,temp)
c
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)
c--
      character*40 iarg1
      data iarg1/'peak(s) coordinates or ##'/
c--
      call xxcln(15)
      n15=0
      md15=8
c      store(nfl+5)=13
c      store(nfl+6)=md15
      l15=nfl+13
      m15=l15
      call sty(iarg1)
1000  continue
      if(klnc(ib)) 2000,1110,2000
1110  continue
      call xpcci
      m15i=m15
      if(jrca(itemp,n)) 3000,1120,3000
1120  continue
      istore(m15i)=itemp(1)
      m=m15+1
      if(jredf(temp,7)) 3000,1100,3000
1100  call trasf(m,1,7)
      m15=m15+md15
      n15=n15+1
      go to 1000
2000  continue
      if(iabort) 2001,2001,3010
2001  continue
      write(ncwu,2010) n15
2010  format(/,i6,' peak(s) stored')
      store(nfl+7)=n15
      n=10+n15*md15
      call frm15
      call xline
      return
3000  call xmhf
3010  continue
      iabort=0
      return
      end
c
code for sw15
      subroutine sw15
c--print list 15 ,peaks
c
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst15/l15,m15,md15,n15
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/xtemp/itemp(80)
      dimension temp(40)
      equivalence(itemp,temp)
c
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)
c--
      call xfl03
      ka=15
      if(kprth(ka)) 900,910,910
900   continue
      call xline
      return
910   continue
      call sfl15
      write (ncwu,4980)
 4980 format(/,3x,'type',4x,'serial',
     1 7x,1hx,9x,1hy,9x,1hz,9x,3hint,5x,'occ',/)
      m15=l15
      do 5040 j=1,n15
      m15i=m15
      il=istore(m15i)
      i=store(m15+6)
      ij=nint(store(m15+1))/100
      write(ncwu,5020) il,ij,store(m15+3),store(m15+4),
     1 store(m15+5),i,store(m15+7)
5020  format(4x,a2,1x,i10,3f10.4,i10,f8.4)
      m15=m15+md15
 5040 continue
      call xline
      return
      end
c
code for sr14
      subroutine sr14
c--read list 14, fourier limits
c
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
      common/lst14/l14,m14,md14,n14,l14a,m14a,md14a,n14a,l14g,n14g,
     2 l14p,l14f,sys14
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,ic,ia,ih
     1 ,numb(10),iplus, inus,ipoint
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/xtemp/itemp(80)
      dimension temp(40)
      equivalence(itemp,temp)
c
      common /xdata/ store(800000)
      dimension     istore(800000)
      equivalence(store,istore)
c--
      dimension itarg(11),ion(2)
      character*40 iarg
      data iarg/'instruction(s) or ##'/
      data nat/11/
      data itarg(1) /4hx   /,itarg(2) /4hy   /,itarg(3)/4hz   /
      data itarg(4) /4hleve/,itarg(5) /4hmult/,itarg(6)/4hf000/
      data itarg(7) /4hpeak/,itarg(8) /4hcond/,itarg(9)/4horie/
      data itarg(10)/4hdefa/,itarg(11)/4hend /
      data ion(1)/4hon  /,ion(2)/4hoff /
c--
      ka=14
c--check if a list 14 exists
      call srlin(ka,li,lj,lk,ll,lm)
      if(lj) 1110,1110,1120
c--set the list 14 address
1110  continue
      ix=0
      call sc014(ix)
      call xcsae
      call xrsl
c--load the current list 14
1120  continue
      call xfl01
      call sfl14
      if(store(l14g+4).ne.sys14) goto 1110
1125  continue
c
c--read the instructions
      call sty(iarg)
c
c--fetch the next card
1000  continue
      if(klnc(i)) 8000,1010,8000
1010  continue
      call xpcci
      if(jrca(itemp,n)) 8000,1012,8000
1012  continue
      in=kcomp(1,itemp,itarg,nat,1)
      if(in) 1040,1040,1030
1030  continue
      go to (2000,2000,2000,3000,
     1 4000,5000,6000,6500,7000,7500,
     2 8000,1040),in
1040  continue
      call xunkw
      go to 1000
c
c--'x','y','z' directives
2000  continue
      if(jredf(temp,4)) 1040,2010,2010
2010  continue
      if(temp(4).gt.0.1) go to 2050
      if(temp(3).le.0.0) temp(3)=0.3
      l=l1p1+(in-1)
      n=store(l)/temp(3)
2020  continue
      if(n-n/4*4) 2030,2040,2030
2030  continue
      n=n-1
      go to 2020
2040  continue
      temp(4)=n
      temp(3)=1
      temp(2)=temp(2)*n
      temp(1)=temp(1)*n
2050  continue
      m14=l14f+(in-1)*md14
      call trasf(m14,1,4)
      m14=l14p+(in-1)*md14
      call trasf(m14,1,4)
      go to 1000
c
c--'level' directive
3000  continue
      m14=l14g+8
3010  continue
      if(jredf(temp,1)) 1040,3020,3020
3020  continue
      call trasf(m14,1,1)
      go to 1000
c
c--'multiply' directive
4000  continue
      m14=l14g+9
      go to 3010
c
c--'f000' directive
5000  continue
      m14=l14g+10
      go to 3010
c
c--'peak' directive
6000  continue
      m14=l14g+11
      go to 3010
c
c--'condition' directive
6500  continue
      m14=l14g+12
      temp(1)=1
      nc=kne(nc,ib,2)
      if(nc) 3020,3020,6510
6510  continue
      if(jrca(itemp(10),n)) 1040,6520,1040
6520  continue
      in=kcomp(1,itemp(10),ion,2,1)
      if(in) 1040,1040,6530
6530  continue
      goto(3020,6540),in
6540  continue
      temp(1)=0
      go to 3020
c
c--'orientation' directive
7000  continue
      i=kredi(n)
      if(i.eq.0.or.i.gt.3) go to 1040
      j=kredi(n)
      if(j.eq.0.or.j.gt.3.or.j.eq.i) go to 1040
      store(l14g+15)=i
      store(l14g+16)=j
      store(l14g+13)=i
      store(l14g+14)=j
      go to 1000
c
c--'default' directive
7500  continue
      ix=0
      call sc014(ix)
      call xcsae
      call xrsl
      call xfl01
      call sfl14
      go to 1000
c
c--'end' or '##' directive
8000  continue
      if(store(l14g+15).ne.0.0) go to 8050
      write(ncwu,8005)
8005  format(' warning:orientation code??' )
8050  continue
      nfl=l14g
      call xfrml(ka,n14g)
      return
      end
c
code for sc014
      subroutine sc014(ix)
c--create a list 14, fourier limits
c
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
      common/lst02/ic,il,g2,isys,ngenc,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
     3 ,l2a,l2b,l2c,l2d,l2j,noric
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst14/l14,m14,md14,n14,l14a,m14a,md14a,n14a,l14g,n14g,
     2 l14p,l14f,sys14
      integer*4 nfl,nl
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xnclu/ncmu,nctu,ncau,ncsu,nclg,nccf
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/xtemp/itemp(80)
      dimension temp(40)
      equivalence(itemp,temp)
c
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)
      character*60 ibuf
      dimension ixyz(3)
      data ihh/2hh /,ixyz/1hx,1hy,1hz/
c--
      call xfl01
      call xfl02
      call xlat(temp)
      fn=g2*n2
      call xfl03
c
c--calculate the number of atoms for the asimetric unit
      m3=l3
      fatom=0.0
      do 1070 i=1,n3
      lj=m3
      if(istore(lj).eq.ihh) go to 1060
      fatom=fatom+store(m3+12)
1060  continue
      m3=m3+md3
1070  continue
      fatom=fatom/fn
c
c--define the asymmetric unit
      l102=nfl
      n102=ipuac(istore(l2s),store(l102),n)
      if(n102) 1074,1074,1079
1074  continue
      call xwarni
      write(ncwu,1075)
1075  format(/,' s.g. code not found.',/,
     1         ' possible error in the grid definition!')
1079  continue
      nfl=l102+n
c
c--set the list 14 address
      ka=14
      sys14=1.00
      call xxcln(ka)
      store(nfl+4)=sys14
      md14=6
      md14a=5
      l14g=nfl
      l14f=l14g+18
      store(l14g+ 5)=18
      store(l14g+ 6)=md14
      store(l14g+ 7)=md14a
      store(l14g+ 8)=20.0
      store(l14g+ 9)=1.0
      store(l14g+10)=0.0
      i=kintk(fatom+fatom*0.30)
      store(l14g+11)=float(i)
      m102=l102
      l14=l14f
      call scx14(m102,n102)
      store(l14g+12)=float(jz)
      store(l14g+15)=n
      store(l14g+16)=j
      l14p=m14a
      store(l14g+17)=l14p-l14g
      l14=l14p
      call scx14(m102,n102)
      store(l14g+13)=n
      store(l14g+14)=j
      n14g=m14a-l14g
      nfl=l14g
      call xfrml(ka,n14g)
      if (ix.eq.0) return
      m14=l14
      do 1100 i=1,3
      write(ibuf,1105) ixyz(i),store(m14),store(m14+1),store(m14+2)
1105  format(a1,3f7.1)
      call prtime(ni,ibuf)
      m14=m14+md14
1100  continue
      write(ibuf,1120) store(l14+8)
1120  format('level ',f7.1)
      call prtime(ni,ibuf)
      write(ibuf,1121) store(l14+11)
1121  format('peak ',f7.1)
      call prtime(ni,ibuf)
      write(ibuf,1122) store(l14g+15),store(l14g+16)
1122  format('orientation ',2f7.0)
      call prtime(ni,ibuf)
      call prtime(ni,'end')
      return
      end
c
code for scx14
      subroutine scx14(m102,n102)
c--insert the limits onto list 14
c
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
      common/lst02/ic,il,g2,isys,ngenc,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
     3 ,l2a,l2b,l2c,l2d,l2j,noric
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst14/l14,m14,md14,n14,l14a,m14a,md14a,n14a,l14g,n14g,
     2 l14p,l14f,sys14
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/xtemp/itemp(80)
      dimension temp(40)
      equivalence(itemp,temp)
c
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)
c--
      m14=l14
      do 1000 i=1,3
      store(m14  )=0.0
      store(m14+1)=0.5
      if(i.eq.3) store(m14+1)=1.0
      store(m14+2)=0.3
      store(m14+4)=0.0
      store(m14+5)=0.0
      m14=m14+md14
1000  continue
      if(isys.eq.1) store(l14+md14+1)=1.0
      if(isys.ge.3) store(l14+2*md14+1)=0.5
      m14a=m14
      jz=0
      if(n102.eq.0) goto 1050
c
c--insert the limits for standard asymmetric unit
      m14=l14
      do 1080 i=1,3
      store(m14  )=store(m102  )
      store(m14+1)=store(m102+1)
      m14=m14+md14
      m102=m102+2
1080  continue
      m14=l14
      do 1090 i=1,3
      do 1095 j=1,2
      n=store(m102)
      m102=m102+1
      if(n.eq.0) goto 1095
      jz=jz+1
      store(m14+3+j)=m14a-l14
      store(m14a )=n
      m14a=m14a+1
      n=n*md14a
      do 1140 k=1,n
      store(m14a)=store(m102)
      m14a=m14a+1
      m102=m102+1
1140  continue
1095  continue
      m14=m14+md14
1090  continue
1050  continue
      nmin=1000
      nmax=0
      l=l1p1
      m14=l14
      do 1040 i=1,3
      n=store(l)/store(m14+2)
1010  continue
      if(n-n/4*4) 1020,1030,1020
1020  continue
      n=n-1
      go to 1010
1030  continue
      store(m14+3)=n
      store(m14+2)=1
      store(m14+1)=store(m14+1)*n
      store(m14  )=store(m14  )*n
      n=store(m14+1)
      nmin=min0(n,nmin)
      nmax=max0(n,nmax)
      l=l+1
      m14=m14+md14
1040  continue
      m14=l14
      do 1045 i=1,3
      n=store(m14+1)
      if(n.ne.nmin) go to 1044
      k=i
      go to 1046
1044  continue
      m14=m14+md14
1045  continue
1046  continue
      m14=l14
      do 1048 i=1,3
      n=store(m14+1)
      if(n.ne.nmax) go to 1047
      if(i.eq.k) go to 1047
      j=i
      go to 1049
1047  continue
      m14=m14+md14
1048  continue
1049  continue
      n=6-k-j
      return
      end
c
code for ipuac
      function ipuac(icode,vet,lvet)
c--function to define the grid of the map
c
      common/xnclu/ncmu,nctu,ncau,ncsu,nclg,nccf
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,ic,ia,ih
     1 ,numb(10),iplus, inus,ipoint
      character*60  jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
      common/xscru/ jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
c--
      character*16 strin1,strin2,idol
c      character*60 ifil
      dimension icode(16),icode1(16),vet(*),buf(60)
c--
      idol='$$$$'
      do 10 i=1,120
      vet(i)=9.9
10    continue
      l=0
      k=1
      do 20 i=1,16
      if(icode(i).eq.ib) then
      if((k.eq.1).or.(l.ne.1)) go to 20
      icode1(k)=icode(i)
      k=k+1
      l=0
      else
      icode1(k)=icode(i)
      k=k+1
      l=1
      endif
20    continue
      ip=ib
      do 30 i=k,16
      icode1(i)=ib
30    continue
      write(strin1,1000)(icode1(n),n=1,16)
1000  format(16a1)
c
c--open the file with the s.g. information
      nlen=300
      if(jopens(ncau,iasun,nlen,ier))9000,1001,1001
1001  continue
c
c--find the space group
40    continue
      read(unit=ncau,fmt=1010,end=900) strin2,jump,ngs,(buf(j),j=1,60)
1010  format(a10,2i5,6f5.1,1x,6f2.0,1x,20(3f3.0,2f5.1))
      if(index(strin1,strin2).ne.0) go to 50
      if(index(idol,strin2).ne.0) goto 900
      go to 40
50    continue
      ipuac=ngs
      lvet=12
      call insua(strin2,vet,buf,lvet)
      if(jump) 1020,1020,1040
1020  continue
      i=iabs(jump)+2
      do 1025 k=1,i
1025  backspace ncau
      read(unit=ncau,fmt=1010,end=900) strin2,jump,ngs,(buf(j),j=1,60)
      goto 1050
1040  continue
      if(jump.eq.1) goto 1050
      i=jump-1
      do 1045 k=1,i
1045  read(unit=ncau,fmt=1010,end=900) strin2,jump,ngs,(buf(j),j=1,60)
1050  continue
c--read the correspondent laue space group
      read(unit=ncau,fmt=1010,end=900) strin2,jump,ngs,(buf(j),j=1,60)
      j=lvet+1
      lvet=lvet+12
      call insua(strin2,vet(j),buf,lvet)
      goto 920
c
c--error messages
900   continue
      if(istat2.ne.0) write(ncwu,1011)
1011  format(2x,'string not found')
910   continue
      ipuac=0
      lvet=0
920   continue
      close(unit=ncau)
      return
9000  continue
      if(istat2.ne.0) write(ncwu,1012)
1012  format(2x,'**error on open file asunit.dat')
      goto 910
      end
c
code for insua
      subroutine insua(strin2,vet,buf,lvet)
c--insert in "vet" the values read from the disc
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      character*16 strin2
      dimension vet(*),buf(60)
c--
      do 60 i=1,6
      if(buf(i).ne.0.0) then
      vet(i)=1/buf(i)
      else
      vet(i)=buf(i)
      endif
60    continue
      j=13
      k=7
      do 90 i=1,6
      vet(k)=buf(i+6)
      k=k+1
      lvet=lvet+buf(i+6)*5
      if(buf(i+6).eq.0.0) go to 90
      nm=buf(i+6)
      do 80 n=1,nm
      do 70 j=j,j+2
      vet(k)=buf(j)
      k=k+1
70    continue
      if(buf(j).ne.0.0) buf(j)=1/buf(j)
      vet(k)=buf(j)
      vet(k+1)=buf(j+1)
      k=k+2
      j=j+2
80    continue
90    continue
      if(istat2.ne.0)  write(ncwu,11) strin2,lvet,(vet(j),j=1,60)
11    format(1x,a16,i5,6(/,1x,10f7.3))
      return
      end
c
code for sw14
      subroutine sw14
c--print list 14, fourier limits
c
      common/lst14/l14,m14,md14,n14,l14a,m14a,md14a,n14a,l14g,n14g,
     2 l14p,l14f,sys14
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
c
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)
c--
      dimension jc1(3),jc2(2,2),jc3(2)
      data jc1/2hx ,2hy ,2hz /,jc3/1h>,1h</
      data jc2(1,1)/2hmi/,jc2(2,1)/2hn)/
      data jc2(1,2)/2hma/,jc2(2,2)/2hx)/
c--
      ka=14
      if(kprth(ka)) 900,910,910
900   continue
      call xline
      return
910   continue
      call sfl14
      if(store(l14g+4).eq.sys14) goto 920
      ix=0
      call sc014(ix)
      call sfl14
920   continue
      l14=l14f
      write(ncwu,1100)
1100  format( /,' fourier limits   : ',7h  min  ,8x,5h  max,11x,
     1 4hstep,9x,'division')
      m14=l14
      do 1300 i=1,3
      write(ncwu,1310) jc1(i),store(m14  ),store(m14+1),
     2 store(m14+2),store(m14+3)
1310  format(9x,a1,4f15.0)
      m14=m14+md14
1300  continue
      if(store(l14g+12).lt.0.5) goto 1201
      m14=l14
      do 1200 i=1,3
      do 1210 j=1,2
      l=store(m14+3+j)
      if(l.gt.0) go to 1220
      write(ncwu,1230) jc1(i),(jc2(k,j),k=1,2)
1230  format(' no condition on ',a1,'(',2a2)
      go to 1210
1220  continue
      l14a=l14+l
      n14a=store(l14a)
      m14a=l14a+1
      write(ncwu,1240) n14a,jc1(i),(jc2(k,j),k=1,2)
1240  format(i3,' condition on ',a1,'(',2a2)
      do 1250 m=1,n14a
      m14b=m14a+md14a-1
      write(ncwu,1260) jc1(i),(jc2(k,j),k=1,2),jc3(j),
     1 (store(l),l=m14a,m14b)
1260  format(1x,a1,'(',2a2,1x,a1,' [ (',f5.2,' * x )',
     1                           ' + (',f5.2,' * y )',
     2                           ' + (',f5.2,' * z )',
     3                           ' +',f5.2,' ] /',f5.2)
      m14a=m14a+md14a
1250  continue
1210  continue
      m14=m14+md14
1200  continue
1201  continue
      i=store(l14g+15)
      j=store(l14g+16)
      k=6-i-j
      write(ncwu,1360) jc1(k),jc1(i),jc1(j)
1360  format(' orientation : ',a1,' layer ; ',a1,' across ; ',
     1 a1,' down .')
      l14=l14p
      write(ncwu,1405)
1405  format( /,' patterson limits : ',7h  min  ,8x,5h  max,11x,
     1 4hstep,9x,'division')
      m14=l14
      do 1402 i=1,3
      write(ncwu,1310) jc1(i),store(m14  ),store(m14+1),
     2 store(m14+2),store(m14+3)
      m14=m14+md14
1402  continue
      if(store(l14g+12).lt.0.5) goto 1401
      m14=l14
      do 1400 i=1,3
      do 1410 j=1,2
      l=store(m14+3+j)
      if(l.gt.0) go to 1420
      write(ncwu,1230) jc1(i),(jc2(k,j),k=1,2)
      go to 1410
1420  continue
      l14a=l14+l
      n14a=store(l14a)
      m14a=l14a+1
      write(ncwu,1240) n14a,jc1(i),(jc2(k,j),k=1,2)
      do 1450 m=1,n14a
      m14b=m14a+md14a-1
      write(ncwu,1260) jc1(i),(jc2(k,j),k=1,2),jc3(j),
     1 (store(l),l=m14a,m14b)
      m14a=m14a+md14a
1450  continue
1410  continue
      m14=m14+md14
1400  continue
1401  continue
      i=store(l14g+13)
      j=store(l14g+14)
      k=6-i-j
      write(ncwu,1360) jc1(k),jc1(i),jc1(j)
      write(ncwu,1320) store(l14g+ 8)
1320  format(/,30h analysis peaks greater than  ,f7.0)
      write(ncwu,1330) store(l14g+ 9)
1330  format( 15h scale factor = ,f7.1)
      write(ncwu,1340) store(l14g+10)
1340  format( 7h f000 = ,f7.1)
      write(ncwu,1350) store(l14g+11)
1350  format( 26h maximum number of peaks  ,f7.0)
      go to 900
      end
c
code for sw16
      subroutine sw16
c--print list 16 ,set of phases
c
      common/lst16/l16,ld16p,m16,m16d,md16d,n16,n16p,l16p
     1 ,l16a,l16k,n16k,numb
      common/lst07/l7,l7a,l7d,ld7p,m7,m7dk,n7dk,md7d,n7d,n7,n7p,
     2 l7rs,l7rk,l7in,l7f,l7e,l7p,n7f,n7dd,ks1,ks2,ks3,sys07
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/xtemp/itemp(80)
      dimension temp(40)
      equivalence(itemp,temp)
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)
c--
      dimension iline(4,5),enil(4),fom(9),cfom(300)
c--
      ka=16
      if(kprth(ka)) 900,910,910
900   continue
      call xline
      return
910   continue
      numero=kredi(i)
      inn=1
      call xfl07(inn)
      n16r=n7f
      call sfl16(cfom,nset)
      if(numero.gt.0) goto 170
      npos = 1
      do 160 j=1,nset
      if (cfom(j) .gt. cfom(npos)) npos = j
  160 continue
c     read to find selected set
  170 if(numero.gt.0) then
                       no=numero
                     else
                       no=npos
                     endif
      numero = no
      l16x=nfl
      l16y=l16x+n16r
      nfl=l16y+n16r
      call snr16(numero,fom,store(l16x),istore(l16y))
      write(ncwu,4940) numero,(fom(i),i=1,5)
 4940 format(/,' set no.=',i5,5x,
     1  'mabs = ',f7.4,3x,'calpha = ',f8.3,3x,'cpsi = ',
     2 f8.3,3x,'cphase= ',f6.2,3x,'combined fom = ',f6.2 ,/)
      write (ncwu,4980)
 4980 format(4('   code   h   k   l  phi    w '))
      m16x=l16x
      m16y=l16y
      mm7=l7f
      jj = 0
      do 5040 il=1,n16r
      jj = jj + 1
      iline(jj,1) = il
      iline(jj,2) = store(mm7  )
      iline(jj,3) = store(mm7+1)
      iline(jj,4) = store(mm7+2)
      iline(jj,5) = istore(m16y)
      enil(jj) = store(m16x)
      m16x=m16x+1
      m16y=m16y+1
      mm7=mm7+md7d
      if (jj-4) 5040,5000,5000
 5000 write (ncwu,5020) ((iline(ii,jj),jj=1,5),enil(ii),ii=1,4)
 5020 format(4(i7,3i4,i5,f6.2))
      jj=0
 5040 continue
      if (jj.ne.0) write(ncwu,5020)((iline(ii,il),il=1,5),
     2 enil(ii),ii=1,jj)
 5200 continue
      call xline
      return
      end
